"""Contains all the data models used in inputs/outputs"""

from .abbreviated_business_model import AbbreviatedBusinessModel
from .access_model import AccessModel
from .activity_report_export_model import ActivityReportExportModel
from .add_note_model import AddNoteModel
from .add_note_model_time_attendance_shift_note_type import AddNoteModelTimeAttendanceShiftNoteType
from .add_note_model_time_attendance_shift_note_visibility import AddNoteModelTimeAttendanceShiftNoteVisibility
from .additional_earnings_input_model import AdditionalEarningsInputModel
from .additional_earnings_model import AdditionalEarningsModel
from .additional_earnings_model_expiration_type_enum import AdditionalEarningsModelExpirationTypeEnum
from .api_employee_expense_grid_model import ApiEmployeeExpenseGridModel
from .api_pay_slip_deduction_model import ApiPaySlipDeductionModel
from .api_pay_slip_leave_model import ApiPaySlipLeaveModel
from .api_pay_slip_payg_adjustment_model import ApiPaySlipPaygAdjustmentModel
from .api_pay_slip_super_adjustment_model import ApiPaySlipSuperAdjustmentModel
from .api_pay_slip_super_payment_model import ApiPaySlipSuperPaymentModel
from .api_year_to_date_earnings_breakdown_model import ApiYearToDateEarningsBreakdownModel
from .apply_leave_request_model import ApplyLeaveRequestModel
from .apply_leave_request_result import ApplyLeaveRequestResult
from .attachment import Attachment
from .attachment_model import AttachmentModel
from .au_accept_roster_shift_response_model import AuAcceptRosterShiftResponseModel
from .au_accept_roster_shifts_response_model import AuAcceptRosterShiftsResponseModel
from .au_active_employees_model import AuActiveEmployeesModel
from .au_add_shift_model import AuAddShiftModel
from .au_add_shift_model_nullable_time_attendance_shift_note_visibility import (
    AuAddShiftModelNullableTimeAttendanceShiftNoteVisibility,
)
from .au_address_model import AuAddressModel
from .au_api_pay_slip_bank_payment_model import AuApiPaySlipBankPaymentModel
from .au_api_pay_slip_earnings_line_model import AuApiPaySlipEarningsLineModel
from .au_api_pay_slip_model import AuApiPaySlipModel
from .au_api_pay_slip_model_rate_unit_enum import AuApiPaySlipModelRateUnitEnum
from .au_auto_pay_configuration_model import AuAutoPayConfigurationModel
from .au_auto_pay_configuration_model_publish_pay_slips_preference import (
    AuAutoPayConfigurationModelPublishPaySlipsPreference,
)
from .au_auto_pay_configuration_model_timesheet_import_option import AuAutoPayConfigurationModelTimesheetImportOption
from .au_available_business_model import AuAvailableBusinessModel
from .au_available_business_model_budget_entry_method_enum import AuAvailableBusinessModelBudgetEntryMethodEnum
from .au_available_business_model_day_of_week import AuAvailableBusinessModelDayOfWeek
from .au_available_business_model_leave_accrual_start_date_type import AuAvailableBusinessModelLeaveAccrualStartDateType
from .au_available_business_model_nullable_billing_status_enum import AuAvailableBusinessModelNullableBillingStatusEnum
from .au_bank_account_model import AuBankAccountModel
from .au_bank_account_model_bank_account_type_enum import AuBankAccountModelBankAccountTypeEnum
from .au_bank_payment_model import AuBankPaymentModel
from .au_billing_plan_response_model import AuBillingPlanResponseModel
from .au_billing_plan_response_model_function_toggle import AuBillingPlanResponseModelFunctionToggle
from .au_billing_plan_response_model_pricing_model_type_enum import AuBillingPlanResponseModelPricingModelTypeEnum
from .au_billing_plan_response_model_super_inclusion_type_enum import AuBillingPlanResponseModelSuperInclusionTypeEnum
from .au_business_export_model import AuBusinessExportModel
from .au_business_export_model_budget_entry_method_enum import AuBusinessExportModelBudgetEntryMethodEnum
from .au_business_export_model_day_of_week import AuBusinessExportModelDayOfWeek
from .au_business_export_model_leave_accrual_start_date_type import AuBusinessExportModelLeaveAccrualStartDateType
from .au_business_export_model_nullable_external_service import AuBusinessExportModelNullableExternalService
from .au_business_export_model_nullable_number_of_employees_range_enum import (
    AuBusinessExportModelNullableNumberOfEmployeesRangeEnum,
)
from .au_business_export_model_nullable_pay_cycle_frequency_enum import (
    AuBusinessExportModelNullablePayCycleFrequencyEnum,
)
from .au_business_hours_leave_request_list_leave_requests_filter_group_by import (
    AuBusinessHoursLeaveRequestListLeaveRequestsFilterGroupBy,
)
from .au_business_hours_leave_request_list_leave_requests_filter_status import (
    AuBusinessHoursLeaveRequestListLeaveRequestsFilterStatus,
)
from .au_business_leave_settings_model import AuBusinessLeaveSettingsModel
from .au_business_leave_settings_model_leave_accrual_start_date_type import (
    AuBusinessLeaveSettingsModelLeaveAccrualStartDateType,
)
from .au_business_leave_settings_model_leave_entitlement_calculation_method_enum import (
    AuBusinessLeaveSettingsModelLeaveEntitlementCalculationMethodEnum,
)
from .au_business_timesheet_settings_model import AuBusinessTimesheetSettingsModel
from .au_chart_of_accounts_default_accounts_model import AuChartOfAccountsDefaultAccountsModel
from .au_chart_of_accounts_default_accounts_model_account_split import AuChartOfAccountsDefaultAccountsModelAccountSplit
from .au_chart_of_accounts_group_model import AuChartOfAccountsGroupModel
from .au_chart_of_accounts_location_accounts_model import AuChartOfAccountsLocationAccountsModel
from .au_chart_of_accounts_location_group_model import AuChartOfAccountsLocationGroupModel
from .au_chart_of_accounts_model import AuChartOfAccountsModel
from .au_clock_on_model import AuClockOnModel
from .au_clock_on_model_nullable_time_attendance_shift_note_visibility import (
    AuClockOnModelNullableTimeAttendanceShiftNoteVisibility,
)
from .au_costing_report_api_model import AuCostingReportApiModel
from .au_costing_report_api_model_i_dictionary_string_decimal import AuCostingReportApiModelIDictionaryStringDecimal
from .au_dashboard_model import AuDashboardModel
from .au_deduction_category_model import AuDeductionCategoryModel
from .au_deduction_category_model_deduction_category_payment_summary_classification import (
    AuDeductionCategoryModelDeductionCategoryPaymentSummaryClassification,
)
from .au_deduction_category_model_external_service import AuDeductionCategoryModelExternalService
from .au_deduction_category_model_sgc_calculation_impact_enum import AuDeductionCategoryModelSGCCalculationImpactEnum
from .au_deduction_model import AuDeductionModel
from .au_detailed_activity_report_export_model import AuDetailedActivityReportExportModel
from .au_detailed_activity_report_export_model_object import AuDetailedActivityReportExportModelObject
from .au_detailed_employee_group_model import AuDetailedEmployeeGroupModel
from .au_detailed_employee_group_model_filter_combination_strategy_enum import (
    AuDetailedEmployeeGroupModelFilterCombinationStrategyEnum,
)
from .au_earnings_line_model import AuEarningsLineModel
from .au_earnings_line_model_i_dictionary_string_i_list_1 import AuEarningsLineModelIDictionaryStringIList1
from .au_earnings_line_model_nullable_lump_sum_calculation_method import (
    AuEarningsLineModelNullableLumpSumCalculationMethod,
)
from .au_edit_business_pay_slip_api_model import AuEditBusinessPaySlipApiModel
from .au_edit_business_pay_slip_api_model_pay_slip_super_contribution_processing_frequency_text_option import (
    AuEditBusinessPaySlipApiModelPaySlipSuperContributionProcessingFrequencyTextOption,
)
from .au_employee_filter_model import AuEmployeeFilterModel
from .au_employee_filter_model_au_filter_type_enum import AuEmployeeFilterModelAuFilterTypeEnum
from .au_employee_filter_model_filter_operator_enum import AuEmployeeFilterModelFilterOperatorEnum
from .au_employee_get_by_external_reference_id_source import AuEmployeeGetByExternalReferenceIdSource
from .au_employee_group_model import AuEmployeeGroupModel
from .au_employee_group_model_filter_combination_strategy_enum import AuEmployeeGroupModelFilterCombinationStrategyEnum
from .au_employee_pay_rate_model import AuEmployeePayRateModel
from .au_employee_portal_settings_model import AuEmployeePortalSettingsModel
from .au_employee_portal_settings_model_ess_timesheet_setting_model_enum import (
    AuEmployeePortalSettingsModelESSTimesheetSettingModelEnum,
)
from .au_employee_recurring_deduction_model import AuEmployeeRecurringDeductionModel
from .au_employee_recurring_deduction_model_au_employee_recurring_deduction_paid_to_enum import (
    AuEmployeeRecurringDeductionModelAuEmployeeRecurringDeductionPaidToEnum,
)
from .au_employee_recurring_deduction_model_deduction_amount_not_reached_enum import (
    AuEmployeeRecurringDeductionModelDeductionAmountNotReachedEnum,
)
from .au_employee_recurring_deduction_model_deduction_type_enum import (
    AuEmployeeRecurringDeductionModelDeductionTypeEnum,
)
from .au_employee_recurring_deduction_model_preserved_earnings_calculation_type_enum import (
    AuEmployeeRecurringDeductionModelPreservedEarningsCalculationTypeEnum,
)
from .au_employing_entity_model import AuEmployingEntityModel
from .au_employing_entity_model_nullable_fbt_exempt_organisation_type_enum import (
    AuEmployingEntityModelNullableFbtExemptOrganisationTypeEnum,
)
from .au_ess_bank_account_model import AuEssBankAccountModel
from .au_ess_bank_account_model_bank_account_type_enum import AuEssBankAccountModelBankAccountTypeEnum
from .au_ess_bulk_roster_shift_action_response import AuEssBulkRosterShiftActionResponse
from .au_ess_employee_details_edit_model import AuEssEmployeeDetailsEditModel
from .au_ess_employee_details_view_model import AuEssEmployeeDetailsViewModel
from .au_ess_employee_save_satisfaction_employee_satisfaction_value import (
    AuEssEmployeeSaveSatisfactionEmployeeSatisfactionValue,
)
from .au_ess_roster_shift_action_response import AuEssRosterShiftActionResponse
from .au_ess_roster_shift_model import AuEssRosterShiftModel
from .au_ess_roster_shift_model_nullable_shift_assignment_status_enum import (
    AuEssRosterShiftModelNullableShiftAssignmentStatusEnum,
)
from .au_ess_save_bank_account_response_model import AuEssSaveBankAccountResponseModel
from .au_ess_time_and_attendance_get_shift_notes_model_type import AuEssTimeAndAttendanceGetShiftNotesModelType
from .au_ess_time_and_attendance_get_shift_notes_model_visibility import (
    AuEssTimeAndAttendanceGetShiftNotesModelVisibility,
)
from .au_ess_timesheet_data_model import AuEssTimesheetDataModel
from .au_ess_work_type_model import AuEssWorkTypeModel
from .au_ess_work_type_model_au_employment_type_enum import AuEssWorkTypeModelAuEmploymentTypeEnum
from .au_ess_work_type_model_nullable_work_type_mapping_type import AuEssWorkTypeModelNullableWorkTypeMappingType
from .au_features_model import AuFeaturesModel
from .au_features_model_ess_timesheet_setting import AuFeaturesModelESSTimesheetSetting
from .au_individual_timesheet_line_model import AuIndividualTimesheetLineModel
from .au_individual_timesheet_line_model_external_service import AuIndividualTimesheetLineModelExternalService
from .au_initial_deduction_model import AuInitialDeductionModel
from .au_initial_earnings_model import AuInitialEarningsModel
from .au_initial_earnings_model_au_pay_category_type import AuInitialEarningsModelAuPayCategoryType
from .au_initiate_employee_onboarding_api_model import AuInitiateEmployeeOnboardingApiModel
from .au_journal_item_response import AuJournalItemResponse
from .au_journal_item_response_i_dictionary_string_i_list_1 import AuJournalItemResponseIDictionaryStringIList1
from .au_journal_item_response_journal_item_type import AuJournalItemResponseJournalItemType
from .au_leave_accrual_rule_model import AuLeaveAccrualRuleModel
from .au_leave_accrual_rule_model_leave_accrual_cap_type import AuLeaveAccrualRuleModelLeaveAccrualCapType
from .au_leave_accrual_rule_model_leave_accrual_carry_over_behaviour import (
    AuLeaveAccrualRuleModelLeaveAccrualCarryOverBehaviour,
)
from .au_leave_accrual_rule_model_leave_accrual_type import AuLeaveAccrualRuleModelLeaveAccrualType
from .au_leave_allowance_model import AuLeaveAllowanceModel
from .au_leave_allowance_template_leave_category_api_model import AuLeaveAllowanceTemplateLeaveCategoryApiModel
from .au_leave_allowance_template_leave_category_api_model_leave_accrual_cap_type import (
    AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualCapType,
)
from .au_leave_allowance_template_leave_category_api_model_leave_accrual_carry_over_behaviour import (
    AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualCarryOverBehaviour,
)
from .au_leave_allowance_template_leave_category_api_model_leave_accrual_type import (
    AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualType,
)
from .au_leave_allowance_template_leave_category_api_model_nullable_leave_allowance_unit_enum import (
    AuLeaveAllowanceTemplateLeaveCategoryApiModelNullableLeaveAllowanceUnitEnum,
)
from .au_leave_allowance_template_leave_category_api_model_nullable_leave_unit_type_enum import (
    AuLeaveAllowanceTemplateLeaveCategoryApiModelNullableLeaveUnitTypeEnum,
)
from .au_leave_allowance_template_model import AuLeaveAllowanceTemplateModel
from .au_leave_allowance_template_model_external_service import AuLeaveAllowanceTemplateModelExternalService
from .au_leave_allowance_template_model_nullable_leave_accrual_start_date_type import (
    AuLeaveAllowanceTemplateModelNullableLeaveAccrualStartDateType,
)
from .au_leave_allowances_get_api_v2_business_by_business_id_leaveallowances_by_employee_id_dictionary_string_i_list_1 import (
    AuLeaveAllowancesGetApiV2BusinessByBusinessIdLeaveallowancesByEmployeeIdDictionaryStringIList1,
)
from .au_leave_allowances_get_dictionary_string_i_list_1 import AuLeaveAllowancesGetDictionaryStringIList1
from .au_leave_allowances_request import AuLeaveAllowancesRequest
from .au_leave_allowances_request_dictionary_string_i_list_1 import AuLeaveAllowancesRequestDictionaryStringIList1
from .au_leave_allowances_request_id_type import AuLeaveAllowancesRequestIdType
from .au_leave_balances_export_model import AuLeaveBalancesExportModel
from .au_leave_balances_export_model_leave_unit_type_enum import AuLeaveBalancesExportModelLeaveUnitTypeEnum
from .au_leave_category_model import AuLeaveCategoryModel
from .au_leave_category_model_au_leave_category_type_enum import AuLeaveCategoryModelAuLeaveCategoryTypeEnum
from .au_leave_category_model_leave_allowance_unit_enum import AuLeaveCategoryModelLeaveAllowanceUnitEnum
from .au_leave_category_model_leave_unit_type_enum import AuLeaveCategoryModelLeaveUnitTypeEnum
from .au_leave_liability_export_model import AuLeaveLiabilityExportModel
from .au_leave_liability_export_model_leave_unit_type_enum import AuLeaveLiabilityExportModelLeaveUnitTypeEnum
from .au_location_model import AuLocationModel
from .au_manager_roster_data_model import AuManagerRosterDataModel
from .au_manager_roster_shift_get_filter_shift_status import AuManagerRosterShiftGetFilterShiftStatus
from .au_manager_roster_shift_get_roster_shift_status import AuManagerRosterShiftGetRosterShiftStatus
from .au_manager_roster_shift_model import AuManagerRosterShiftModel
from .au_manager_roster_shift_model_nullable_shift_assignment_status_enum import (
    AuManagerRosterShiftModelNullableShiftAssignmentStatusEnum,
)
from .au_opening_balances_model import AuOpeningBalancesModel
from .au_ordinary_time_earnings_api_model import AuOrdinaryTimeEarningsApiModel
from .au_pay_categories_model import AuPayCategoriesModel
from .au_pay_category_model import AuPayCategoryModel
from .au_pay_category_model_au_pay_category_type import AuPayCategoryModelAuPayCategoryType
from .au_pay_category_model_nullable_midpoint_rounding import AuPayCategoryModelNullableMidpointRounding
from .au_pay_category_model_nullable_pay_category_payment_summary_classification import (
    AuPayCategoryModelNullablePayCategoryPaymentSummaryClassification,
)
from .au_pay_category_model_rate_unit_enum import AuPayCategoryModelRateUnitEnum
from .au_pay_rate_template_model import AuPayRateTemplateModel
from .au_pay_run_deduction_response import AuPayRunDeductionResponse
from .au_pay_run_deduction_response_dictionary_string_list_1 import AuPayRunDeductionResponseDictionaryStringList1
from .au_pay_run_details_model import AuPayRunDetailsModel
from .au_pay_run_earnings_line_response_model import AuPayRunEarningsLineResponseModel
from .au_pay_run_earnings_line_response_model_dictionary_string_list_1 import (
    AuPayRunEarningsLineResponseModelDictionaryStringList1,
)
from .au_pay_run_grand_total_model import AuPayRunGrandTotalModel
from .au_pay_run_inclusion_export_model import AuPayRunInclusionExportModel
from .au_pay_run_pay_slip_get_dictionary_string_au_api_pay_slip_model import (
    AuPayRunPaySlipGetDictionaryStringAuApiPaySlipModel,
)
from .au_pay_run_total_detail_model import AuPayRunTotalDetailModel
from .au_pay_run_total_model import AuPayRunTotalModel
from .au_pay_run_total_response import AuPayRunTotalResponse
from .au_pay_run_total_response_dictionary_string_au_pay_run_total_model import (
    AuPayRunTotalResponseDictionaryStringAuPayRunTotalModel,
)
from .au_pay_schedule_model import AuPayScheduleModel
from .au_pay_schedule_model_au_pay_cycle_frequency_enum import AuPayScheduleModelAuPayCycleFrequencyEnum
from .au_pay_schedule_model_nullable_pay_run_employee_selection_strategy import (
    AuPayScheduleModelNullablePayRunEmployeeSelectionStrategy,
)
from .au_payment_history_model import AuPaymentHistoryModel
from .au_reports_detailed_activity_get_excel_file_request_filter_type import (
    AuReportsDetailedActivityGetExcelFileRequestFilterType,
)
from .au_reports_detailed_activity_get_excel_file_request_group_by import (
    AuReportsDetailedActivityGetExcelFileRequestGroupBy,
)
from .au_reports_gross_to_net_get_excel_report_request_filter_type import (
    AuReportsGrossToNetGetExcelReportRequestFilterType,
)
from .au_reports_gross_to_net_get_request_filter_type import AuReportsGrossToNetGetRequestFilterType
from .au_reports_leave_balances_get_excel_report_request_filter_type import (
    AuReportsLeaveBalancesGetExcelReportRequestFilterType,
)
from .au_reports_leave_balances_get_excel_report_request_group_by import (
    AuReportsLeaveBalancesGetExcelReportRequestGroupBy,
)
from .au_reports_leave_balances_get_request_group_by import AuReportsLeaveBalancesGetRequestGroupBy
from .au_reports_leave_liability_get_request_filter_type import AuReportsLeaveLiabilityGetRequestFilterType
from .au_reports_leave_liability_get_request_group_by import AuReportsLeaveLiabilityGetRequestGroupBy
from .au_reports_pay_run_inclusions_get_request_status import AuReportsPayRunInclusionsGetRequestStatus
from .au_reports_payroll_tax_get_request_group_by import AuReportsPayrollTaxGetRequestGroupBy
from .au_reports_roster_timesheet_comparison_get_roster_shift_status import (
    AuReportsRosterTimesheetComparisonGetRosterShiftStatus,
)
from .au_reports_roster_timesheet_comparison_get_timesheet_line_status_type import (
    AuReportsRosterTimesheetComparisonGetTimesheetLineStatusType,
)
from .au_reports_super_contributions_get_excel_report_request_contribution_type import (
    AuReportsSuperContributionsGetExcelReportRequestContributionType,
)
from .au_reports_super_contributions_get_excel_report_request_filter_type import (
    AuReportsSuperContributionsGetExcelReportRequestFilterType,
)
from .au_reports_super_contributions_get_excel_report_request_group_by import (
    AuReportsSuperContributionsGetExcelReportRequestGroupBy,
)
from .au_reports_super_contributions_get_excel_report_request_super_contributions_report_export_type import (
    AuReportsSuperContributionsGetExcelReportRequestSuperContributionsReportExportType,
)
from .au_reports_timesheet_get_timesheet_line_status_type import AuReportsTimesheetGetTimesheetLineStatusType
from .au_roster_shift_edit_model import AuRosterShiftEditModel
from .au_roster_shift_generate_timesheet_model import AuRosterShiftGenerateTimesheetModel
from .au_roster_shift_generate_timesheet_model_nullable_shift_assignment_status_enum import (
    AuRosterShiftGenerateTimesheetModelNullableShiftAssignmentStatusEnum,
)
from .au_roster_shift_get_filter_shift_status import AuRosterShiftGetFilterShiftStatus
from .au_roster_shift_get_roster_shift_status import AuRosterShiftGetRosterShiftStatus
from .au_roster_shift_matching_result_model import AuRosterShiftMatchingResultModel
from .au_roster_timesheet_comparison_report_export_model import AuRosterTimesheetComparisonReportExportModel
from .au_roster_timesheet_comparison_report_request_model import AuRosterTimesheetComparisonReportRequestModel
from .au_roster_timesheet_comparison_report_request_model_roster_shift_status import (
    AuRosterTimesheetComparisonReportRequestModelRosterShiftStatus,
)
from .au_roster_timesheet_comparison_report_request_model_timesheet_line_status_type import (
    AuRosterTimesheetComparisonReportRequestModelTimesheetLineStatusType,
)
from .au_save_bank_account_response_model import AuSaveBankAccountResponseModel
from .au_single_location_model import AuSingleLocationModel
from .au_smsf_electronic_service_address_model import AuSmsfElectronicServiceAddressModel
from .au_stp_registration_model import AuStpRegistrationModel
from .au_stp_registration_model_ato_integration_option import AuStpRegistrationModelAtoIntegrationOption
from .au_stp_registration_model_ato_supplier_role import AuStpRegistrationModelAtoSupplierRole
from .au_submit_pay_run_earnings_line_request import AuSubmitPayRunEarningsLineRequest
from .au_submit_pay_run_earnings_line_request_dictionary_string_list_1 import (
    AuSubmitPayRunEarningsLineRequestDictionaryStringList1,
)
from .au_submit_pay_run_earnings_line_request_id_type import AuSubmitPayRunEarningsLineRequestIdType
from .au_submit_timesheets_request import AuSubmitTimesheetsRequest
from .au_submit_timesheets_request_i_dictionary_string_i_list_1 import AuSubmitTimesheetsRequestIDictionaryStringIList1
from .au_submit_timesheets_request_id_type import AuSubmitTimesheetsRequestIdType
from .au_submit_timesheets_response import AuSubmitTimesheetsResponse
from .au_submit_timesheets_response_i_dictionary_string_i_list_1 import (
    AuSubmitTimesheetsResponseIDictionaryStringIList1,
)
from .au_time_and_attendance_kiosk_model import AuTimeAndAttendanceKioskModel
from .au_time_and_attendance_lookup_data_model import AuTimeAndAttendanceLookupDataModel
from .au_time_and_attendance_shift_model import AuTimeAndAttendanceShiftModel
from .au_timesheet_export_model import AuTimesheetExportModel
from .au_timesheet_line_model import AuTimesheetLineModel
from .au_timesheet_line_model_external_service import AuTimesheetLineModelExternalService
from .au_timesheet_reference_data import AuTimesheetReferenceData
from .au_unstructured_employee_model import AuUnstructuredEmployeeModel
from .au_unstructured_employee_model_employee_status_enum import AuUnstructuredEmployeeModelEmployeeStatusEnum
from .au_unstructured_employee_model_nullable_closely_held_reporting_enum import (
    AuUnstructuredEmployeeModelNullableCloselyHeldReportingEnum,
)
from .au_unstructured_employee_model_nullable_leave_accrual_start_date_type import (
    AuUnstructuredEmployeeModelNullableLeaveAccrualStartDateType,
)
from .au_unstructured_employee_model_nullable_medicare_levy_surcharge_withholding_tier import (
    AuUnstructuredEmployeeModelNullableMedicareLevySurchargeWithholdingTier,
)
from .au_unstructured_employee_model_nullable_stp_income_type_enum import (
    AuUnstructuredEmployeeModelNullableStpIncomeTypeEnum,
)
from .au_unstructured_employee_model_nullable_tax_file_declaration_tax_category_combination import (
    AuUnstructuredEmployeeModelNullableTaxFileDeclarationTaxCategoryCombination,
)
from .au_user_account_metadata import AuUserAccountMetadata
from .au_user_account_partner_metadata import AuUserAccountPartnerMetadata
from .au_work_type_model import AuWorkTypeModel
from .au_work_type_model_au_employment_type_enum import AuWorkTypeModelAuEmploymentTypeEnum
from .au_work_type_model_nullable_work_type_mapping_type import AuWorkTypeModelNullableWorkTypeMappingType
from .available_employee_model import AvailableEmployeeModel
from .bank_account_edit_model import BankAccountEditModel
from .bank_account_edit_model_bank_account_type_enum import BankAccountEditModelBankAccountTypeEnum
from .bank_account_edit_model_external_service import BankAccountEditModelExternalService
from .bank_account_edit_model_i_dictionary_string_string import BankAccountEditModelIDictionaryStringString
from .basic_employment_agreement_model import BasicEmploymentAgreementModel
from .basic_employment_agreement_model_au_employment_type_enum import BasicEmploymentAgreementModelAuEmploymentTypeEnum
from .basic_kiosk_employee_model import BasicKioskEmployeeModel
from .basic_kiosk_employee_model_time_attendance_status import BasicKioskEmployeeModelTimeAttendanceStatus
from .bidding_employee import BiddingEmployee
from .birthday_report_export_model import BirthdayReportExportModel
from .brand_model import BrandModel
from .bulk_apply_leave_request_model import BulkApplyLeaveRequestModel
from .business_aba_model import BusinessAbaModel
from .business_aba_model_nullable_payment_file_balance_additional_content import (
    BusinessAbaModelNullablePaymentFileBalanceAdditionalContent,
)
from .business_aba_model_nullable_payment_file_payment_additional_content import (
    BusinessAbaModelNullablePaymentFilePaymentAdditionalContent,
)
from .business_access_list_model import BusinessAccessListModel
from .business_access_list_model_related_user_type import BusinessAccessListModelRelatedUserType
from .business_access_model import BusinessAccessModel
from .business_access_model_related_user_type import BusinessAccessModelRelatedUserType
from .business_action import BusinessAction
from .business_ato_supplier_model import BusinessAtoSupplierModel
from .business_ato_supplier_model_ato_supplier_role import BusinessAtoSupplierModelAtoSupplierRole
from .business_metadata_omop_model import BusinessMetadataOmopModel
from .business_template_model import BusinessTemplateModel
from .byte_array_content import ByteArrayContent
from .change_kiosk_pin_model import ChangeKioskPinModel
from .chart_of_accounts_category_model import ChartOfAccountsCategoryModel
from .chart_of_accounts_leave_category_model import ChartOfAccountsLeaveCategoryModel
from .chart_of_accounts_liability_category_model import ChartOfAccountsLiabilityCategoryModel
from .chart_of_accounts_liability_location_category_model import ChartOfAccountsLiabilityLocationCategoryModel
from .chart_of_accounts_location_category_model import ChartOfAccountsLocationCategoryModel
from .chart_of_accounts_location_leave_category_model import ChartOfAccountsLocationLeaveCategoryModel
from .check_kiosk_employee_id_model import CheckKioskEmployeeIdModel
from .check_kiosk_pin_model import CheckKioskPinModel
from .classification_lookup_model import ClassificationLookupModel
from .classification_select_model import ClassificationSelectModel
from .classification_selection import ClassificationSelection
from .clock_off_model import ClockOffModel
from .clock_off_model_nullable_time_attendance_shift_note_visibility import (
    ClockOffModelNullableTimeAttendanceShiftNoteVisibility,
)
from .clock_on_model import ClockOnModel
from .clock_on_model_nullable_time_attendance_shift_note_visibility import (
    ClockOnModelNullableTimeAttendanceShiftNoteVisibility,
)
from .communication_message_attachment_model import CommunicationMessageAttachmentModel
from .conversation_status_update_hook_model import ConversationStatusUpdateHookModel
from .costing_report_request_model import CostingReportRequestModel
from .create_business_access_model import CreateBusinessAccessModel
from .create_business_access_model_related_user_type import CreateBusinessAccessModelRelatedUserType
from .create_employee_access_model import CreateEmployeeAccessModel
from .create_employee_note_model import CreateEmployeeNoteModel
from .decline_leave_request import DeclineLeaveRequest
from .decline_reason import DeclineReason
from .deduction_model import DeductionModel
from .deductions_report_deduction_amount_model import DeductionsReportDeductionAmountModel
from .deductions_report_export_model import DeductionsReportExportModel
from .deductions_report_request_model import DeductionsReportRequestModel
from .detailed_activity_report_request_model import DetailedActivityReportRequestModel
from .detailed_activity_report_request_model_date_type_enum import DetailedActivityReportRequestModelDateTypeEnum
from .detailed_activity_report_request_model_earnings_report_display_enum import (
    DetailedActivityReportRequestModelEarningsReportDisplayEnum,
)
from .detailed_pay_run_warning_model import DetailedPayRunWarningModel
from .detailed_pay_run_warning_model_pay_run_warning_type import DetailedPayRunWarningModelPayRunWarningType
from .device_token_model import DeviceTokenModel
from .device_token_model_mobile_platform import DeviceTokenModelMobilePlatform
from .dimension_earnings_line_split_api_model import DimensionEarningsLineSplitApiModel
from .document_acknowledgements_report_export_model import DocumentAcknowledgementsReportExportModel
from .document_file import DocumentFile
from .document_model import DocumentModel
from .earnings_line_split_api_model import EarningsLineSplitApiModel
from .earnings_line_split_edit_model import EarningsLineSplitEditModel
from .emergency_contact_edit_model import EmergencyContactEditModel
from .employee_access_model import EmployeeAccessModel
from .employee_agreement import EmployeeAgreement
from .employee_agreement_object import EmployeeAgreementObject
from .employee_details_audit_report_api_model import EmployeeDetailsAuditReportApiModel
from .employee_details_audit_report_request_model import EmployeeDetailsAuditReportRequestModel
from .employee_details_audit_report_request_model_nullable_employee_audit_section import (
    EmployeeDetailsAuditReportRequestModelNullableEmployeeAuditSection,
)
from .employee_details_fields import EmployeeDetailsFields
from .employee_details_model import EmployeeDetailsModel
from .employee_details_report_field import EmployeeDetailsReportField
from .employee_details_report_request_model import EmployeeDetailsReportRequestModel
from .employee_document_model import EmployeeDocumentModel
from .employee_emergency_contacts_edit_model import EmployeeEmergencyContactsEditModel
from .employee_expense_category_model import EmployeeExpenseCategoryModel
from .employee_expense_model import EmployeeExpenseModel
from .employee_expense_model_i_dictionary_string_i_list_1 import EmployeeExpenseModelIDictionaryStringIList1
from .employee_expense_payment_summary_model import EmployeeExpensePaymentSummaryModel
from .employee_group_access_model import EmployeeGroupAccessModel
from .employee_group_access_model_user_permission import EmployeeGroupAccessModelUserPermission
from .employee_group_item_model import EmployeeGroupItemModel
from .employee_group_permission_model import EmployeeGroupPermissionModel
from .employee_item_count_model import EmployeeItemCountModel
from .employee_leave_request_filter import EmployeeLeaveRequestFilter
from .employee_metadata_omop_model import EmployeeMetadataOmopModel
from .employee_note_model import EmployeeNoteModel
from .employee_partial_edit_model import EmployeePartialEditModel
from .employee_partial_edit_model_employee_starter_type_enum import EmployeePartialEditModelEmployeeStarterTypeEnum
from .employee_partial_edit_model_employee_timesheet_setting import EmployeePartialEditModelEmployeeTimesheetSetting
from .employee_partial_edit_model_external_service import EmployeePartialEditModelExternalService
from .employee_partial_edit_model_i_dictionary_string_string import EmployeePartialEditModelIDictionaryStringString
from .employee_partial_edit_model_nullable_address_type_enum import EmployeePartialEditModelNullableAddressTypeEnum
from .employee_public_holiday_filter import EmployeePublicHolidayFilter
from .employee_qualification_document_model import EmployeeQualificationDocumentModel
from .employee_qualification_model import EmployeeQualificationModel
from .employee_qualification_request import EmployeeQualificationRequest
from .employee_recurring_expense_model import EmployeeRecurringExpenseModel
from .employee_recurring_super_adjustment_model import EmployeeRecurringSuperAdjustmentModel
from .employee_recurring_super_adjustment_model_super_adjustment_type_enum import (
    EmployeeRecurringSuperAdjustmentModelSuperAdjustmentTypeEnum,
)
from .employee_recurring_super_adjustment_model_super_contribution_type import (
    EmployeeRecurringSuperAdjustmentModelSuperContributionType,
)
from .employee_recurring_tax_adjustment_model import EmployeeRecurringTaxAdjustmentModel
from .employee_recurring_tax_adjustment_model_tax_adjustment_type_enum import (
    EmployeeRecurringTaxAdjustmentModelTaxAdjustmentTypeEnum,
)
from .employee_timesheet_filter import EmployeeTimesheetFilter
from .employee_unavailability_filter import EmployeeUnavailabilityFilter
from .employee_update_response_model import EmployeeUpdateResponseModel
from .employee_view_model import EmployeeViewModel
from .employees_filter import EmployeesFilter
from .employer_liability_category_model import EmployerLiabilityCategoryModel
from .employer_liability_model import EmployerLiabilityModel
from .employer_recurring_liability_model import EmployerRecurringLiabilityModel
from .employer_recurring_liability_model_employer_recurring_liability_type_enum import (
    EmployerRecurringLiabilityModelEmployerRecurringLiabilityTypeEnum,
)
from .employer_recurring_liability_model_external_service import EmployerRecurringLiabilityModelExternalService
from .employment_agreement_model import EmploymentAgreementModel
from .employment_agreement_model_employment_type_enum import EmploymentAgreementModelEmploymentTypeEnum
from .employment_agreement_model_external_service import EmploymentAgreementModelExternalService
from .employment_agreement_model_pay_rate_template_type_enum import EmploymentAgreementModelPayRateTemplateTypeEnum
from .employment_agreement_pay_rate_template_model import EmploymentAgreementPayRateTemplateModel
from .employment_termination_payment import EmploymentTerminationPayment
from .employment_termination_payment_etp_type_enum import EmploymentTerminationPaymentEtpTypeEnum
from .end_break_model import EndBreakModel
from .end_break_model_nullable_time_attendance_shift_note_visibility import (
    EndBreakModelNullableTimeAttendanceShiftNoteVisibility,
)
from .entitlement_feature_model import EntitlementFeatureModel
from .entitlements_model import EntitlementsModel
from .ess_bulk_accept_roster_shifts_model import EssBulkAcceptRosterShiftsModel
from .ess_bulk_decline_roster_shifts_model import EssBulkDeclineRosterShiftsModel
from .ess_bulk_roster_shift_swap_model import EssBulkRosterShiftSwapModel
from .ess_current_expenses_model import EssCurrentExpensesModel
from .ess_current_shift_model import EssCurrentShiftModel
from .ess_current_shift_model_time_attendance_status import EssCurrentShiftModelTimeAttendanceStatus
from .ess_current_timesheets_model import EssCurrentTimesheetsModel
from .ess_decline_roster_shift_model import EssDeclineRosterShiftModel
from .ess_document_model import EssDocumentModel
from .ess_employee_details_model import EssEmployeeDetailsModel
from .ess_employee_details_model_employee_details_edit_mode import EssEmployeeDetailsModelEmployeeDetailsEditMode
from .ess_employee_details_model_employee_timesheet_setting import EssEmployeeDetailsModelEmployeeTimesheetSetting
from .ess_employee_details_model_nullable_address_type_enum import EssEmployeeDetailsModelNullableAddressTypeEnum
from .ess_employee_details_model_termination_reason_enum import EssEmployeeDetailsModelTerminationReasonEnum
from .ess_employee_qualification_document_model import EssEmployeeQualificationDocumentModel
from .ess_employee_qualification_model import EssEmployeeQualificationModel
from .ess_expense_request_response_model import EssExpenseRequestResponseModel
from .ess_expense_upload_attachment_i_http_action_result import EssExpenseUploadAttachmentIHttpActionResult
from .ess_leave_category_model import EssLeaveCategoryModel
from .ess_leave_category_model_leave_unit_type_enum import EssLeaveCategoryModelLeaveUnitTypeEnum
from .ess_leave_estimate import EssLeaveEstimate
from .ess_leave_request_model import EssLeaveRequestModel
from .ess_leave_request_model_leave_unit_type_enum import EssLeaveRequestModelLeaveUnitTypeEnum
from .ess_leave_upload_i_http_action_result import EssLeaveUploadIHttpActionResult
from .ess_payment_summary_model import EssPaymentSummaryModel
from .ess_payslip_model import EssPayslipModel
from .ess_qualification_upload_attachment_i_http_action_result import EssQualificationUploadAttachmentIHttpActionResult
from .ess_roster_shift_count_model import EssRosterShiftCountModel
from .ess_satisfaction_survey import EssSatisfactionSurvey
from .ess_satisfaction_survey_employee_satisfaction_value import EssSatisfactionSurveyEmployeeSatisfactionValue
from .ess_shift_swap_candidate import EssShiftSwapCandidate
from .ess_timesheet_model import EssTimesheetModel
from .ess_timesheet_model_external_service import EssTimesheetModelExternalService
from .ess_timesheet_model_timesheet_line_status_type import EssTimesheetModelTimesheetLineStatusType
from .ess_unavailability_model import EssUnavailabilityModel
from .ess_unavailability_model_nullable_day_of_week import EssUnavailabilityModelNullableDayOfWeek
from .ess_unavailability_model_nullable_day_of_week_flags_enum import EssUnavailabilityModelNullableDayOfWeekFlagsEnum
from .ess_work_type_model import EssWorkTypeModel
from .ess_work_type_model_employment_type_enum import EssWorkTypeModelEmploymentTypeEnum
from .ess_work_type_model_nullable_work_type_mapping_type import EssWorkTypeModelNullableWorkTypeMappingType
from .expense_category_response_model import ExpenseCategoryResponseModel
from .expense_management_filter_model import ExpenseManagementFilterModel
from .expense_management_filter_model_nullable_employee_expense_request_group_by import (
    ExpenseManagementFilterModelNullableEmployeeExpenseRequestGroupBy,
)
from .expense_management_filter_model_nullable_employee_expense_request_status import (
    ExpenseManagementFilterModelNullableEmployeeExpenseRequestStatus,
)
from .expense_reference_data import ExpenseReferenceData
from .expense_request_edit_line_item_model import ExpenseRequestEditLineItemModel
from .expense_request_edit_model import ExpenseRequestEditModel
from .expense_request_line_item_model import ExpenseRequestLineItemModel
from .expense_request_response_model import ExpenseRequestResponseModel
from .expense_request_upload_attachment_i_http_action_result import ExpenseRequestUploadAttachmentIHttpActionResult
from .expense_tax_code import ExpenseTaxCode
from .filter_clause import FilterClause
from .filter_query_option import FilterQueryOption
from .filter_query_validator import FilterQueryValidator
from .finalise_pay_run_options import FinalisePayRunOptions
from .finalise_pay_run_options_nullable_hmrc_fps_late_submission_reason import (
    FinalisePayRunOptionsNullableHmrcFpsLateSubmissionReason,
)
from .finalise_pay_run_options_nullable_pay_run_finalise_action_preference import (
    FinalisePayRunOptionsNullablePayRunFinaliseActionPreference,
)
from .finalise_pay_run_options_publish_pay_slips_preference import FinalisePayRunOptionsPublishPaySlipsPreference
from .generic_manager_time_and_attendance_get_shift_notes_model_type import (
    GenericManagerTimeAndAttendanceGetShiftNotesModelType,
)
from .generic_manager_time_and_attendance_get_shift_notes_model_visibility import (
    GenericManagerTimeAndAttendanceGetShiftNotesModelVisibility,
)
from .generic_manager_timesheet_get_filter_order_by import GenericManagerTimesheetGetFilterOrderBy
from .generic_manager_timesheet_get_filter_status import GenericManagerTimesheetGetFilterStatus
from .generic_time_and_attendance_get_shift_notes_model_type import GenericTimeAndAttendanceGetShiftNotesModelType
from .generic_time_and_attendance_get_shift_notes_model_visibility import (
    GenericTimeAndAttendanceGetShiftNotesModelVisibility,
)
from .get_shift_notes_model import GetShiftNotesModel
from .get_shift_notes_model_nullable_time_attendance_shift_note_type import (
    GetShiftNotesModelNullableTimeAttendanceShiftNoteType,
)
from .get_shift_notes_model_nullable_time_attendance_shift_note_visibility import (
    GetShiftNotesModelNullableTimeAttendanceShiftNoteVisibility,
)
from .get_shift_periods_model import GetShiftPeriodsModel
from .get_shifts_model import GetShiftsModel
from .gross_to_net_report_request import GrossToNetReportRequest
from .gross_to_net_report_request_nullable_date_type_enum import GrossToNetReportRequestNullableDateTypeEnum
from .hour_leave_estimate_model import HourLeaveEstimateModel
from .hour_leave_request_model import HourLeaveRequestModel
from .hour_leave_request_response_model import HourLeaveRequestResponseModel
from .i_edm_direct_value_annotations_manager import IEdmDirectValueAnnotationsManager
from .i_edm_model import IEdmModel
from .i_edm_schema_element import IEdmSchemaElement
from .i_edm_schema_element_edm_schema_element_kind import IEdmSchemaElementEdmSchemaElementKind
from .i_edm_term import IEdmTerm
from .i_edm_term_edm_schema_element_kind import IEdmTermEdmSchemaElementKind
from .i_edm_term_edm_term_kind import IEdmTermEdmTermKind
from .i_edm_type import IEdmType
from .i_edm_type_edm_type_kind import IEdmTypeEdmTypeKind
from .i_edm_type_reference import IEdmTypeReference
from .i_edm_vocabulary_annotatable import IEdmVocabularyAnnotatable
from .i_edm_vocabulary_annotation import IEdmVocabularyAnnotation
from .i_future_value_int_32 import IFutureValueInt32
from .i_leave_based_roster_shift import ILeaveBasedRosterShift
from .initial_employer_liability_model import InitialEmployerLiabilityModel
from .initial_leave_balance_model import InitialLeaveBalanceModel
from .initial_leave_balance_model_leave_unit_type_enum import InitialLeaveBalanceModelLeaveUnitTypeEnum
from .inline_count_query_option import InlineCountQueryOption
from .inline_count_query_option_inline_count_value import InlineCountQueryOptionInlineCountValue
from .invoice_line_item_detail_model import InvoiceLineItemDetailModel
from .invoice_line_item_model import InvoiceLineItemModel
from .invoice_model import InvoiceModel
from .invoice_query_options_model import InvoiceQueryOptionsModel
from .journal_account_bulk_create_model import JournalAccountBulkCreateModel
from .journal_account_model import JournalAccountModel
from .journal_account_model_external_account_type import JournalAccountModelExternalAccountType
from .journal_export_result import JournalExportResult
from .journal_export_result_external_service import JournalExportResultExternalService
from .journal_export_result_journal_export_status import JournalExportResultJournalExportStatus
from .journal_service_provider_model import JournalServiceProviderModel
from .journal_service_tax_code import JournalServiceTaxCode
from .key_value_pair_string_i_enumerable_1 import KeyValuePairStringIEnumerable1
from .kiosk_access_model import KioskAccessModel
from .kiosk_access_model_kiosk_access_type import KioskAccessModelKioskAccessType
from .kiosk_access_model_user_permission import KioskAccessModelUserPermission
from .kiosk_create_employee_model import KioskCreateEmployeeModel
from .kiosk_employee_model import KioskEmployeeModel
from .kiosk_employee_model_time_attendance_status import KioskEmployeeModelTimeAttendanceStatus
from .leave_accrual_model import LeaveAccrualModel
from .leave_accrual_response import LeaveAccrualResponse
from .leave_accrual_response_dictionary_string_list_1 import LeaveAccrualResponseDictionaryStringList1
from .leave_allowance_template_leave_category_model import LeaveAllowanceTemplateLeaveCategoryModel
from .leave_allowance_template_leave_category_model_leave_accrual_cap_type import (
    LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualCapType,
)
from .leave_allowance_template_leave_category_model_leave_accrual_carry_over_behaviour import (
    LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualCarryOverBehaviour,
)
from .leave_allowance_template_leave_category_model_leave_accrual_type import (
    LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualType,
)
from .leave_allowance_template_leave_category_model_nullable_leave_allowance_unit_enum import (
    LeaveAllowanceTemplateLeaveCategoryModelNullableLeaveAllowanceUnitEnum,
)
from .leave_allowance_template_model import LeaveAllowanceTemplateModel
from .leave_allowance_template_model_external_service import LeaveAllowanceTemplateModelExternalService
from .leave_allowance_template_model_nullable_leave_accrual_start_date_type import (
    LeaveAllowanceTemplateModelNullableLeaveAccrualStartDateType,
)
from .leave_application_with_attachment_model import LeaveApplicationWithAttachmentModel
from .leave_balance_model import LeaveBalanceModel
from .leave_balance_model_leave_unit_type_enum import LeaveBalanceModelLeaveUnitTypeEnum
from .leave_balances_report_export_request import LeaveBalancesReportExportRequest
from .leave_balances_report_export_request_date_type_enum import LeaveBalancesReportExportRequestDateTypeEnum
from .leave_balances_report_export_request_leave_report_display_enum import (
    LeaveBalancesReportExportRequestLeaveReportDisplayEnum,
)
from .leave_balances_report_request_model import LeaveBalancesReportRequestModel
from .leave_balances_report_request_model_leave_report_display_enum import (
    LeaveBalancesReportRequestModelLeaveReportDisplayEnum,
)
from .leave_entitlement_model import LeaveEntitlementModel
from .leave_entitlement_model_leave_entitlement_accrual_unit_type import (
    LeaveEntitlementModelLeaveEntitlementAccrualUnitType,
)
from .leave_entitlement_model_leave_entitlement_carry_over_type import (
    LeaveEntitlementModelLeaveEntitlementCarryOverType,
)
from .leave_entitlement_model_leave_entitlement_forfeiture_type import (
    LeaveEntitlementModelLeaveEntitlementForfeitureType,
)
from .leave_entitlement_model_leave_entitlement_leave_balance_type import (
    LeaveEntitlementModelLeaveEntitlementLeaveBalanceType,
)
from .leave_entitlement_tier_model import LeaveEntitlementTierModel
from .leave_entitlement_tier_model_leave_entitlement_accrual_start_date_unit_type import (
    LeaveEntitlementTierModelLeaveEntitlementAccrualStartDateUnitType,
)
from .leave_entitlement_tier_model_leave_entitlement_accrual_unit_type import (
    LeaveEntitlementTierModelLeaveEntitlementAccrualUnitType,
)
from .leave_history_api_report_model import LeaveHistoryApiReportModel
from .leave_history_report_detail_model import LeaveHistoryReportDetailModel
from .leave_history_report_detail_model_leave_unit_type_enum import LeaveHistoryReportDetailModelLeaveUnitTypeEnum
from .leave_history_report_group_model import LeaveHistoryReportGroupModel
from .leave_history_report_group_model_leave_unit_type_enum import LeaveHistoryReportGroupModelLeaveUnitTypeEnum
from .leave_hours_estimate_filter import LeaveHoursEstimateFilter
from .leave_request_filter_model import LeaveRequestFilterModel
from .leave_request_filter_model_leave_request_group_by import LeaveRequestFilterModelLeaveRequestGroupBy
from .leave_request_filter_model_nullable_leave_request_status import LeaveRequestFilterModelNullableLeaveRequestStatus
from .location_access_model import LocationAccessModel
from .location_access_model_location_restriction_filter_type_enum import (
    LocationAccessModelLocationRestrictionFilterTypeEnum,
)
from .location_access_model_user_permission import LocationAccessModelUserPermission
from .location_item_model import LocationItemModel
from .location_model import LocationModel
from .location_permission_model import LocationPermissionModel
from .location_select_model import LocationSelectModel
from .location_shift_conditions_model import LocationShiftConditionsModel
from .magic_token_response_model import MagicTokenResponseModel
from .manager_biddable_roster_shift_model import ManagerBiddableRosterShiftModel
from .manager_biddable_roster_shift_model_nullable_shift_assignment_status_enum import (
    ManagerBiddableRosterShiftModelNullableShiftAssignmentStatusEnum,
)
from .manager_current_roster_shift import ManagerCurrentRosterShift
from .manager_current_roster_shift_time_attendance_status import ManagerCurrentRosterShiftTimeAttendanceStatus
from .manager_dashboard_model import ManagerDashboardModel
from .manager_employee_group import ManagerEmployeeGroup
from .manager_expense_employee_model import ManagerExpenseEmployeeModel
from .manager_expense_get_filter_group_by import ManagerExpenseGetFilterGroupBy
from .manager_expense_get_filter_status import ManagerExpenseGetFilterStatus
from .manager_expense_request_model import ManagerExpenseRequestModel
from .manager_item_count_model import ManagerItemCountModel
from .manager_leave_application_model import ManagerLeaveApplicationModel
from .manager_leave_category_model import ManagerLeaveCategoryModel
from .manager_leave_employee_model import ManagerLeaveEmployeeModel
from .manager_leave_estimate import ManagerLeaveEstimate
from .manager_leave_request_list_leave_requests_filter_group_by import ManagerLeaveRequestListLeaveRequestsFilterGroupBy
from .manager_leave_request_list_leave_requests_filter_status import ManagerLeaveRequestListLeaveRequestsFilterStatus
from .manager_leave_request_model import ManagerLeaveRequestModel
from .manager_leave_request_model_leave_unit_type_enum import ManagerLeaveRequestModelLeaveUnitTypeEnum
from .manager_roster_employee_model import ManagerRosterEmployeeModel
from .manager_roster_shift_filter_model import ManagerRosterShiftFilterModel
from .manager_timesheet_employee_model import ManagerTimesheetEmployeeModel
from .manager_timesheet_line_model import ManagerTimesheetLineModel
from .manager_timesheet_line_model_external_service import ManagerTimesheetLineModelExternalService
from .manager_timesheet_line_model_timesheet_line_status_type import ManagerTimesheetLineModelTimesheetLineStatusType
from .manager_timesheet_submit_model import ManagerTimesheetSubmitModel
from .manager_timesheet_submit_model_nullable_external_service import ManagerTimesheetSubmitModelNullableExternalService
from .manager_unavailability_model import ManagerUnavailabilityModel
from .manager_unavailability_model_nullable_day_of_week import ManagerUnavailabilityModelNullableDayOfWeek
from .manager_unavailability_model_nullable_day_of_week_flags_enum import (
    ManagerUnavailabilityModelNullableDayOfWeekFlagsEnum,
)
from .mark_notes_read_view_model import MarkNotesReadViewModel
from .matching_employee_model import MatchingEmployeeModel
from .metadata_lite import MetadataLite
from .mlc_super_report_export_model import MLCSuperReportExportModel
from .name_id_pair import NameIdPair
from .net_to_gross_model import NetToGrossModel
from .net_to_gross_request import NetToGrossRequest
from .new_user_created_model import NewUserCreatedModel
from .new_user_model import NewUserModel
from .nominal_classification import NominalClassification
from .nominal_leave_category import NominalLeaveCategory
from .nominal_location import NominalLocation
from .nominal_work_type import NominalWorkType
from .nominal_work_type_work_type_link_type_restriction import NominalWorkTypeWorkTypeLinkTypeRestriction
from .numeric_nullable_select_list_item import NumericNullableSelectListItem
from .numeric_select_list_item import NumericSelectListItem
from .o_data_query_context import ODataQueryContext
from .o_data_query_validator import ODataQueryValidator
from .o_data_raw_query_options import ODataRawQueryOptions
from .opening_balances_etp_model import OpeningBalancesEtpModel
from .opening_balances_etp_model_etp_type_enum import OpeningBalancesEtpModelEtpTypeEnum
from .order_by_clause import OrderByClause
from .order_by_clause_order_by_direction import OrderByClauseOrderByDirection
from .order_by_node import OrderByNode
from .order_by_node_order_by_direction import OrderByNodeOrderByDirection
from .order_by_query_option import OrderByQueryOption
from .order_by_query_validator import OrderByQueryValidator
from .ordinary_time_earnings_report_request_model import OrdinaryTimeEarningsReportRequestModel
from .other_amounts import OtherAmounts
from .paged_result_model_manager_expense_request_model import PagedResultModelManagerExpenseRequestModel
from .paged_result_model_manager_timesheet_line_model import PagedResultModelManagerTimesheetLineModel
from .paged_result_model_suburb_model import PagedResultModelSuburbModel
from .partially_applied_leave_request_banner_model import PartiallyAppliedLeaveRequestBannerModel
from .pay_categories_report_request_model import PayCategoriesReportRequestModel
from .pay_condition_rule_set_model import PayConditionRuleSetModel
from .pay_condition_rule_set_model_nullable_shift_consolidation_option import (
    PayConditionRuleSetModelNullableShiftConsolidationOption,
)
from .pay_condition_rule_set_model_rule_set_period_type import PayConditionRuleSetModelRuleSetPeriodType
from .pay_rate_schedule_model import PayRateScheduleModel
from .pay_rate_template_model import PayRateTemplateModel
from .pay_rate_template_pay_category_export_model import PayRateTemplatePayCategoryExportModel
from .pay_rate_template_pay_category_model import PayRateTemplatePayCategoryModel
from .pay_run_audit_report_request_model import PayRunAuditReportRequestModel
from .pay_run_create_and_finalise_multiple_response import PayRunCreateAndFinaliseMultipleResponse
from .pay_run_create_and_finalise_multiple_result import PayRunCreateAndFinaliseMultipleResult
from .pay_run_create_multiple_request import PayRunCreateMultipleRequest
from .pay_run_create_multiple_request_dates import PayRunCreateMultipleRequestDates
from .pay_run_create_multiple_request_nullable_timesheet_import_option import (
    PayRunCreateMultipleRequestNullableTimesheetImportOption,
)
from .pay_run_create_request import PayRunCreateRequest
from .pay_run_create_request_nullable_timesheet_import_option import PayRunCreateRequestNullableTimesheetImportOption
from .pay_run_employee_expense_response import PayRunEmployeeExpenseResponse
from .pay_run_employee_expense_response_dictionary_string_list_1 import (
    PayRunEmployeeExpenseResponseDictionaryStringList1,
)
from .pay_run_employer_liability_response import PayRunEmployerLiabilityResponse
from .pay_run_employer_liability_response_dictionary_string_list_1 import (
    PayRunEmployerLiabilityResponseDictionaryStringList1,
)
from .pay_run_finalise_default_settings_model import PayRunFinaliseDefaultSettingsModel
from .pay_run_finalise_default_settings_model_pay_run_finalise_action_preference import (
    PayRunFinaliseDefaultSettingsModelPayRunFinaliseActionPreference,
)
from .pay_run_finalise_default_settings_model_pay_run_finalise_action_timeline import (
    PayRunFinaliseDefaultSettingsModelPayRunFinaliseActionTimeline,
)
from .pay_run_finalise_result import PayRunFinaliseResult
from .pay_run_finalise_result_pay_run_finalise_action_preference import (
    PayRunFinaliseResultPayRunFinaliseActionPreference,
)
from .pay_run_finalise_result_publish_pay_slips_preference import PayRunFinaliseResultPublishPaySlipsPreference
from .pay_run_inclusions_report_request_model import PayRunInclusionsReportRequestModel
from .pay_run_inclusions_report_request_model_pay_run_inclusions_status import (
    PayRunInclusionsReportRequestModelPayRunInclusionsStatus,
)
from .pay_run_job_model import PayRunJobModel
from .pay_run_job_status_model import PayRunJobStatusModel
from .pay_run_model import PayRunModel
from .pay_run_notation_model import PayRunNotationModel
from .pay_run_payg_adjustment_response import PayRunPaygAdjustmentResponse
from .pay_run_payg_adjustment_response_dictionary_string_list_1 import PayRunPaygAdjustmentResponseDictionaryStringList1
from .pay_run_summary_model import PayRunSummaryModel
from .pay_run_super_adjustment_response import PayRunSuperAdjustmentResponse
from .pay_run_super_adjustment_response_dictionary_string_list_1 import (
    PayRunSuperAdjustmentResponseDictionaryStringList1,
)
from .pay_run_super_batch_model import PayRunSuperBatchModel
from .pay_run_total_model import PayRunTotalModel
from .pay_run_total_notation_model import PayRunTotalNotationModel
from .pay_run_unlock_request import PayRunUnlockRequest
from .pay_run_warning_dto import PayRunWarningDto
from .pay_run_warning_dto_object import PayRunWarningDtoObject
from .pay_run_warning_dto_pay_run_warning_type import PayRunWarningDtoPayRunWarningType
from .pay_run_warning_model import PayRunWarningModel
from .pay_run_warning_result import PayRunWarningResult
from .pay_schedule_approval_settings_model import PayScheduleApprovalSettingsModel
from .pay_schedule_date_forecast_result_api_model import PayScheduleDateForecastResultApiModel
from .pay_schedule_meta_data_model import PayScheduleMetaDataModel
from .pay_slip_notification_response import PaySlipNotificationResponse
from .pay_slip_report_request_model import PaySlipReportRequestModel
from .payg_adjustment_model import PaygAdjustmentModel
from .payg_report_export_model import PaygReportExportModel
from .payg_report_request_model import PaygReportRequestModel
from .payment_history_report_request_model import PaymentHistoryReportRequestModel
from .payroll_access_model import PayrollAccessModel
from .payroll_access_model_nullable_business_restriction_type_enum import (
    PayrollAccessModelNullableBusinessRestrictionTypeEnum,
)
from .payroll_exempt_report_export_model import PayrollExemptReportExportModel
from .payroll_exempt_report_request_model import PayrollExemptReportRequestModel
from .payroll_export import PayrollExport
from .payroll_tax_report_export_model import PayrollTaxReportExportModel
from .payroll_tax_report_request_model import PayrollTaxReportRequestModel
from .payroll_tax_report_request_model_payroll_tax_group_by_enum import (
    PayrollTaxReportRequestModelPayrollTaxGroupByEnum,
)
from .pin_reset_model import PinResetModel
from .profile_image_metadata import ProfileImageMetadata
from .public_holiday_model import PublicHolidayModel
from .qualification_model import QualificationModel
from .range_variable import RangeVariable
from .rate_override import RateOverride
from .recover_password_model import RecoverPasswordModel
from .recover_password_model_message_type_enum import RecoverPasswordModelMessageTypeEnum
from .related_businesses_model import RelatedBusinessesModel
from .report_access_model import ReportAccessModel
from .report_access_model_report_access_type import ReportAccessModelReportAccessType
from .report_access_model_report_enum import ReportAccessModelReportEnum
from .report_leave_liability_preparation_response import ReportLeaveLiabilityPreparationResponse
from .report_leave_liability_preparation_response_long_running_job_status import (
    ReportLeaveLiabilityPreparationResponseLongRunningJobStatus,
)
from .report_leave_liability_request_model import ReportLeaveLiabilityRequestModel
from .report_leave_liability_request_model_date_type_enum import ReportLeaveLiabilityRequestModelDateTypeEnum
from .report_leave_liability_request_model_nullable_leave_report_display_enum import (
    ReportLeaveLiabilityRequestModelNullableLeaveReportDisplayEnum,
)
from .report_pack_model import ReportPackModel
from .report_pay_run_variance_request_model import ReportPayRunVarianceRequestModel
from .report_pay_run_variance_request_model_pay_run_comparison_type import (
    ReportPayRunVarianceRequestModelPayRunComparisonType,
)
from .report_request_with_pay_schedule_model import ReportRequestWithPayScheduleModel
from .reporting_dimension_api_model import ReportingDimensionApiModel
from .reporting_dimension_api_model_external_service import ReportingDimensionApiModelExternalService
from .reporting_dimension_value_api_model import ReportingDimensionValueApiModel
from .reporting_dimension_value_api_model_external_service import ReportingDimensionValueApiModelExternalService
from .reporting_dimension_value_base_api_model import ReportingDimensionValueBaseApiModel
from .reporting_dimension_value_filter_api_model import ReportingDimensionValueFilterApiModel
from .reporting_dimension_value_select_model import ReportingDimensionValueSelectModel
from .reports_employee_audit_get_request_section import ReportsEmployeeAuditGetRequestSection
from .reports_employee_details_get_j_object import ReportsEmployeeDetailsGetJObject
from .reports_employee_details_post_j_object import ReportsEmployeeDetailsPostJObject
from .reports_pay_run_variance_report_get_excel_report_request_comparison_type import (
    ReportsPayRunVarianceReportGetExcelReportRequestComparisonType,
)
from .reports_shift_swapping_get_roster_shift_swap_status_enum import ReportsShiftSwappingGetRosterShiftSwapStatusEnum
from .reports_tasks_report_get_request_status import ReportsTasksReportGetRequestStatus
from .reseller_model import ResellerModel
from .roster_live_leave_accruals import RosterLiveLeaveAccruals
from .roster_shift_break_api_model import RosterShiftBreakApiModel
from .roster_shift_edit_model import RosterShiftEditModel
from .roster_shift_filter_model import RosterShiftFilterModel
from .roster_shift_filter_model_roster_shift_status import RosterShiftFilterModelRosterShiftStatus
from .roster_shift_role import RosterShiftRole
from .roster_shift_swap_model import RosterShiftSwapModel
from .rule_evaluation_result import RuleEvaluationResult
from .rule_evaluation_result_rule_match_result import RuleEvaluationResultRuleMatchResult
from .save_leave_accrual_model import SaveLeaveAccrualModel
from .save_leave_accrual_model_save_leave_accrual_type_enum import SaveLeaveAccrualModelSaveLeaveAccrualTypeEnum
from .save_super_fund_model import SaveSuperFundModel
from .save_super_fund_response_model import SaveSuperFundResponseModel
from .select_expand_clause import SelectExpandClause
from .select_expand_query_option import SelectExpandQueryOption
from .select_expand_query_validator import SelectExpandQueryValidator
from .select_item import SelectItem
from .select_list_group import SelectListGroup
from .select_list_item import SelectListItem
from .self_managed_super_fund_model import SelfManagedSuperFundModel
from .set_billing_plan_request_model import SetBillingPlanRequestModel
from .set_pay_run_ui_unlock_state_request import SetPayRunUIUnlockStateRequest
from .shift_allowance_model import ShiftAllowanceModel
from .shift_allowance_model_shift_allowance_option import ShiftAllowanceModelShiftAllowanceOption
from .shift_allowance_model_shift_allowance_type import ShiftAllowanceModelShiftAllowanceType
from .shift_break_model import ShiftBreakModel
from .shift_break_model_nullable_time_attendance_shift_note_visibility import (
    ShiftBreakModelNullableTimeAttendanceShiftNoteVisibility,
)
from .shift_condition import ShiftCondition
from .shift_condition_model import ShiftConditionModel
from .shift_condition_select_model import ShiftConditionSelectModel
from .shift_costing_breakdown_model import ShiftCostingBreakdownModel
from .shift_costing_data import ShiftCostingData
from .shift_costings_employee_model import ShiftCostingsEmployeeModel
from .shift_costings_request_model import ShiftCostingsRequestModel
from .shift_costings_request_model_id_type import ShiftCostingsRequestModelIdType
from .shift_costings_request_shift_model import ShiftCostingsRequestShiftModel
from .shift_costings_request_shift_model_external_service import ShiftCostingsRequestShiftModelExternalService
from .shift_costings_response_model import ShiftCostingsResponseModel
from .shift_costings_response_shift_model import ShiftCostingsResponseShiftModel
from .shift_liability_model import ShiftLiabilityModel
from .shift_liability_model_shift_allowance_option import ShiftLiabilityModelShiftAllowanceOption
from .shift_note_view_model import ShiftNoteViewModel
from .shift_note_view_model_time_attendance_shift_note_type import ShiftNoteViewModelTimeAttendanceShiftNoteType
from .shift_note_view_model_time_attendance_shift_note_visibility import (
    ShiftNoteViewModelTimeAttendanceShiftNoteVisibility,
)
from .shift_part_model import ShiftPartModel
from .shift_period_model import ShiftPeriodModel
from .shift_swapping_report_export_model import ShiftSwappingReportExportModel
from .shift_swapping_report_request_model import ShiftSwappingReportRequestModel
from .shift_swapping_report_request_model_roster_shift_swap_status_enum import (
    ShiftSwappingReportRequestModelRosterShiftSwapStatusEnum,
)
from .signup_model import SignupModel
from .single_sign_on_request_additional_data_model import SingleSignOnRequestAdditionalDataModel
from .single_sign_on_request_model import SingleSignOnRequestModel
from .single_sign_on_request_model_navigation_display_enum import SingleSignOnRequestModelNavigationDisplayEnum
from .single_sign_on_response_model import SingleSignOnResponseModel
from .single_value_node import SingleValueNode
from .single_value_node_query_node_kind import SingleValueNodeQueryNodeKind
from .skip_query_option import SkipQueryOption
from .skip_query_validator import SkipQueryValidator
from .standard_hours_day_model import StandardHoursDayModel
from .standard_hours_day_model_nullable_work_day_type import StandardHoursDayModelNullableWorkDayType
from .standard_hours_model import StandardHoursModel
from .standard_hours_model_nullable_advanced_work_week_configuration_option import (
    StandardHoursModelNullableAdvancedWorkWeekConfigurationOption,
)
from .start_break_model import StartBreakModel
from .start_break_model_nullable_time_attendance_shift_note_visibility import (
    StartBreakModelNullableTimeAttendanceShiftNoteVisibility,
)
from .stub_roster_shift_view_model import StubRosterShiftViewModel
from .submit_leave_accruals_model import SubmitLeaveAccrualsModel
from .submit_leave_accruals_model_dictionary_string_list_1 import SubmitLeaveAccrualsModelDictionaryStringList1
from .submit_leave_accruals_model_id_type import SubmitLeaveAccrualsModelIdType
from .submit_pay_run_deduction_request import SubmitPayRunDeductionRequest
from .submit_pay_run_deduction_request_dictionary_string_list_1 import SubmitPayRunDeductionRequestDictionaryStringList1
from .submit_pay_run_deduction_request_id_type import SubmitPayRunDeductionRequestIdType
from .submit_pay_run_employee_expense_request import SubmitPayRunEmployeeExpenseRequest
from .submit_pay_run_employee_expense_request_dictionary_string_list_1 import (
    SubmitPayRunEmployeeExpenseRequestDictionaryStringList1,
)
from .submit_pay_run_employee_expense_request_id_type import SubmitPayRunEmployeeExpenseRequestIdType
from .submit_pay_run_employer_liability_request import SubmitPayRunEmployerLiabilityRequest
from .submit_pay_run_employer_liability_request_dictionary_string_list_1 import (
    SubmitPayRunEmployerLiabilityRequestDictionaryStringList1,
)
from .submit_pay_run_employer_liability_request_id_type import SubmitPayRunEmployerLiabilityRequestIdType
from .submit_pay_run_payg_adjustment_request import SubmitPayRunPaygAdjustmentRequest
from .submit_pay_run_payg_adjustment_request_dictionary_string_list_1 import (
    SubmitPayRunPaygAdjustmentRequestDictionaryStringList1,
)
from .submit_pay_run_payg_adjustment_request_id_type import SubmitPayRunPaygAdjustmentRequestIdType
from .submit_pay_run_super_adjustment_request import SubmitPayRunSuperAdjustmentRequest
from .submit_pay_run_super_adjustment_request_dictionary_string_list_1 import (
    SubmitPayRunSuperAdjustmentRequestDictionaryStringList1,
)
from .submit_pay_run_super_adjustment_request_id_type import SubmitPayRunSuperAdjustmentRequestIdType
from .suburb_model import SuburbModel
from .suburb_result import SuburbResult
from .super_accrual_export_model import SuperAccrualExportModel
from .super_accrual_export_model_nullable_super_interchange_status import (
    SuperAccrualExportModelNullableSuperInterchangeStatus,
)
from .super_adjustment_model import SuperAdjustmentModel
from .super_contributions_report_export_model import SuperContributionsReportExportModel
from .super_contributions_report_request_model import SuperContributionsReportRequestModel
from .super_contributions_report_request_model_contributions_service_type import (
    SuperContributionsReportRequestModelContributionsServiceType,
)
from .super_contributions_report_request_model_date_type_enum import SuperContributionsReportRequestModelDateTypeEnum
from .super_contributions_report_request_model_nullable_super_contribution_type import (
    SuperContributionsReportRequestModelNullableSuperContributionType,
)
from .super_contributions_report_request_model_super_contributions_report_export_type_enum import (
    SuperContributionsReportRequestModelSuperContributionsReportExportTypeEnum,
)
from .super_fund_model import SuperFundModel
from .super_product_edit_model import SuperProductEditModel
from .super_product_edit_model_external_service import SuperProductEditModelExternalService
from .super_product_model import SuperProductModel
from .super_product_model_external_service import SuperProductModelExternalService
from .swap_shift_model import SwapShiftModel
from .system_event_type import SystemEventType
from .tag_view_model import TagViewModel
from .tasks_report_export_model import TasksReportExportModel
from .tasks_report_note_model import TasksReportNoteModel
from .tasks_report_request_model import TasksReportRequestModel
from .tasks_report_request_model_tasks_report_status_enum import TasksReportRequestModelTasksReportStatusEnum
from .terminate_employee_request import TerminateEmployeeRequest
from .time_and_attendance_break_model import TimeAndAttendanceBreakModel
from .time_and_attendance_kiosk_model import TimeAndAttendanceKioskModel
from .timesheet_array import TimesheetArray
from .timesheet_break_manager_model import TimesheetBreakManagerModel
from .timesheet_break_model import TimesheetBreakModel
from .timesheet_break_modelv_3 import TimesheetBreakModelv3
from .timesheet_break_submit_model import TimesheetBreakSubmitModel
from .timesheet_break_view_model import TimesheetBreakViewModel
from .timesheet_line_comments_model import TimesheetLineCommentsModel
from .timesheet_line_model import TimesheetLineModel
from .timesheet_line_model_external_service import TimesheetLineModelExternalService
from .timesheet_pay_return_array import TimesheetPayReturnArray
from .timesheet_report_request_model import TimesheetReportRequestModel
from .timesheet_report_request_model_timesheet_line_status_type import (
    TimesheetReportRequestModelTimesheetLineStatusType,
)
from .timesheet_request_filter_model import TimesheetRequestFilterModel
from .timesheet_request_filter_model_nullable_timesheet_grouping import (
    TimesheetRequestFilterModelNullableTimesheetGrouping,
)
from .timesheet_request_filter_model_nullable_timesheet_line_filter_status import (
    TimesheetRequestFilterModelNullableTimesheetLineFilterStatus,
)
from .timesheet_rounding_rules_model import TimesheetRoundingRulesModel
from .timesheet_rounding_rules_model_rounding_direction_enum import TimesheetRoundingRulesModelRoundingDirectionEnum
from .timesheet_shift_condition_model import TimesheetShiftConditionModel
from .timesheet_shift_condition_modelv_3 import TimesheetShiftConditionModelv3
from .title_view_model import TitleViewModel
from .token_post_request import TokenPostRequest
from .top_query_option import TopQueryOption
from .top_query_validator import TopQueryValidator
from .unavailability_edit_model import UnavailabilityEditModel
from .unavailability_edit_model_nullable_day_of_week import UnavailabilityEditModelNullableDayOfWeek
from .unavailability_edit_model_nullable_day_of_week_flags_enum import UnavailabilityEditModelNullableDayOfWeekFlagsEnum
from .unavailability_filter import UnavailabilityFilter
from .unavailability_model import UnavailabilityModel
from .unavailability_model_nullable_day_of_week import UnavailabilityModelNullableDayOfWeek
from .unavailability_model_nullable_day_of_week_flags_enum import UnavailabilityModelNullableDayOfWeekFlagsEnum
from .unavailability_save_model import UnavailabilitySaveModel
from .unavailability_save_model_nullable_day_of_week import UnavailabilitySaveModelNullableDayOfWeek
from .unit_and_hour_leave_estimate_model import UnitAndHourLeaveEstimateModel
from .update_document_permissions_model import UpdateDocumentPermissionsModel
from .update_employee_document_permissions_model import UpdateEmployeeDocumentPermissionsModel
from .update_user_model import UpdateUserModel
from .user_access_model import UserAccessModel
from .user_access_model_nullable_related_user_type import UserAccessModelNullableRelatedUserType
from .user_account_metadata_lite import UserAccountMetadataLite
from .user_account_metadata_omop_model import UserAccountMetadataOmopModel
from .user_model import UserModel
from .user_updated_model import UserUpdatedModel
from .web_hook import WebHook
from .web_hook_i_dictionary_string_object import WebHookIDictionaryStringObject
from .web_hook_i_dictionary_string_object_object import WebHookIDictionaryStringObjectObject
from .web_hook_i_dictionary_string_string import WebHookIDictionaryStringString
from .web_hook_registrations_delete_all_i_http_action_result import WebHookRegistrationsDeleteAllIHttpActionResult
from .web_hook_registrations_delete_i_http_action_result import WebHookRegistrationsDeleteIHttpActionResult
from .web_hook_registrations_put_i_http_action_result import WebHookRegistrationsPutIHttpActionResult
from .web_hook_registrations_test_i_http_action_result import WebHookRegistrationsTestIHttpActionResult
from .white_label_active_employees_request_model import WhiteLabelActiveEmployeesRequestModel
from .white_label_branding_model import WhiteLabelBrandingModel
from .white_label_model import WhiteLabelModel
from .white_label_report_signups_request_model import WhiteLabelReportSignupsRequestModel
from .work_type_select_model import WorkTypeSelectModel
from .workers_comp_report_grid_model import WorkersCompReportGridModel

__all__ = (
    "AbbreviatedBusinessModel",
    "AccessModel",
    "ActivityReportExportModel",
    "AdditionalEarningsInputModel",
    "AdditionalEarningsModel",
    "AdditionalEarningsModelExpirationTypeEnum",
    "AddNoteModel",
    "AddNoteModelTimeAttendanceShiftNoteType",
    "AddNoteModelTimeAttendanceShiftNoteVisibility",
    "ApiEmployeeExpenseGridModel",
    "ApiPaySlipDeductionModel",
    "ApiPaySlipLeaveModel",
    "ApiPaySlipPaygAdjustmentModel",
    "ApiPaySlipSuperAdjustmentModel",
    "ApiPaySlipSuperPaymentModel",
    "ApiYearToDateEarningsBreakdownModel",
    "ApplyLeaveRequestModel",
    "ApplyLeaveRequestResult",
    "Attachment",
    "AttachmentModel",
    "AuAcceptRosterShiftResponseModel",
    "AuAcceptRosterShiftsResponseModel",
    "AuActiveEmployeesModel",
    "AuAddressModel",
    "AuAddShiftModel",
    "AuAddShiftModelNullableTimeAttendanceShiftNoteVisibility",
    "AuApiPaySlipBankPaymentModel",
    "AuApiPaySlipEarningsLineModel",
    "AuApiPaySlipModel",
    "AuApiPaySlipModelRateUnitEnum",
    "AuAutoPayConfigurationModel",
    "AuAutoPayConfigurationModelPublishPaySlipsPreference",
    "AuAutoPayConfigurationModelTimesheetImportOption",
    "AuAvailableBusinessModel",
    "AuAvailableBusinessModelBudgetEntryMethodEnum",
    "AuAvailableBusinessModelDayOfWeek",
    "AuAvailableBusinessModelLeaveAccrualStartDateType",
    "AuAvailableBusinessModelNullableBillingStatusEnum",
    "AuBankAccountModel",
    "AuBankAccountModelBankAccountTypeEnum",
    "AuBankPaymentModel",
    "AuBillingPlanResponseModel",
    "AuBillingPlanResponseModelFunctionToggle",
    "AuBillingPlanResponseModelPricingModelTypeEnum",
    "AuBillingPlanResponseModelSuperInclusionTypeEnum",
    "AuBusinessExportModel",
    "AuBusinessExportModelBudgetEntryMethodEnum",
    "AuBusinessExportModelDayOfWeek",
    "AuBusinessExportModelLeaveAccrualStartDateType",
    "AuBusinessExportModelNullableExternalService",
    "AuBusinessExportModelNullableNumberOfEmployeesRangeEnum",
    "AuBusinessExportModelNullablePayCycleFrequencyEnum",
    "AuBusinessHoursLeaveRequestListLeaveRequestsFilterGroupBy",
    "AuBusinessHoursLeaveRequestListLeaveRequestsFilterStatus",
    "AuBusinessLeaveSettingsModel",
    "AuBusinessLeaveSettingsModelLeaveAccrualStartDateType",
    "AuBusinessLeaveSettingsModelLeaveEntitlementCalculationMethodEnum",
    "AuBusinessTimesheetSettingsModel",
    "AuChartOfAccountsDefaultAccountsModel",
    "AuChartOfAccountsDefaultAccountsModelAccountSplit",
    "AuChartOfAccountsGroupModel",
    "AuChartOfAccountsLocationAccountsModel",
    "AuChartOfAccountsLocationGroupModel",
    "AuChartOfAccountsModel",
    "AuClockOnModel",
    "AuClockOnModelNullableTimeAttendanceShiftNoteVisibility",
    "AuCostingReportApiModel",
    "AuCostingReportApiModelIDictionaryStringDecimal",
    "AuDashboardModel",
    "AuDeductionCategoryModel",
    "AuDeductionCategoryModelDeductionCategoryPaymentSummaryClassification",
    "AuDeductionCategoryModelExternalService",
    "AuDeductionCategoryModelSGCCalculationImpactEnum",
    "AuDeductionModel",
    "AuDetailedActivityReportExportModel",
    "AuDetailedActivityReportExportModelObject",
    "AuDetailedEmployeeGroupModel",
    "AuDetailedEmployeeGroupModelFilterCombinationStrategyEnum",
    "AuEarningsLineModel",
    "AuEarningsLineModelIDictionaryStringIList1",
    "AuEarningsLineModelNullableLumpSumCalculationMethod",
    "AuEditBusinessPaySlipApiModel",
    "AuEditBusinessPaySlipApiModelPaySlipSuperContributionProcessingFrequencyTextOption",
    "AuEmployeeFilterModel",
    "AuEmployeeFilterModelAuFilterTypeEnum",
    "AuEmployeeFilterModelFilterOperatorEnum",
    "AuEmployeeGetByExternalReferenceIdSource",
    "AuEmployeeGroupModel",
    "AuEmployeeGroupModelFilterCombinationStrategyEnum",
    "AuEmployeePayRateModel",
    "AuEmployeePortalSettingsModel",
    "AuEmployeePortalSettingsModelESSTimesheetSettingModelEnum",
    "AuEmployeeRecurringDeductionModel",
    "AuEmployeeRecurringDeductionModelAuEmployeeRecurringDeductionPaidToEnum",
    "AuEmployeeRecurringDeductionModelDeductionAmountNotReachedEnum",
    "AuEmployeeRecurringDeductionModelDeductionTypeEnum",
    "AuEmployeeRecurringDeductionModelPreservedEarningsCalculationTypeEnum",
    "AuEmployingEntityModel",
    "AuEmployingEntityModelNullableFbtExemptOrganisationTypeEnum",
    "AuEssBankAccountModel",
    "AuEssBankAccountModelBankAccountTypeEnum",
    "AuEssBulkRosterShiftActionResponse",
    "AuEssEmployeeDetailsEditModel",
    "AuEssEmployeeDetailsViewModel",
    "AuEssEmployeeSaveSatisfactionEmployeeSatisfactionValue",
    "AuEssRosterShiftActionResponse",
    "AuEssRosterShiftModel",
    "AuEssRosterShiftModelNullableShiftAssignmentStatusEnum",
    "AuEssSaveBankAccountResponseModel",
    "AuEssTimeAndAttendanceGetShiftNotesModelType",
    "AuEssTimeAndAttendanceGetShiftNotesModelVisibility",
    "AuEssTimesheetDataModel",
    "AuEssWorkTypeModel",
    "AuEssWorkTypeModelAuEmploymentTypeEnum",
    "AuEssWorkTypeModelNullableWorkTypeMappingType",
    "AuFeaturesModel",
    "AuFeaturesModelESSTimesheetSetting",
    "AuIndividualTimesheetLineModel",
    "AuIndividualTimesheetLineModelExternalService",
    "AuInitialDeductionModel",
    "AuInitialEarningsModel",
    "AuInitialEarningsModelAuPayCategoryType",
    "AuInitiateEmployeeOnboardingApiModel",
    "AuJournalItemResponse",
    "AuJournalItemResponseIDictionaryStringIList1",
    "AuJournalItemResponseJournalItemType",
    "AuLeaveAccrualRuleModel",
    "AuLeaveAccrualRuleModelLeaveAccrualCapType",
    "AuLeaveAccrualRuleModelLeaveAccrualCarryOverBehaviour",
    "AuLeaveAccrualRuleModelLeaveAccrualType",
    "AuLeaveAllowanceModel",
    "AuLeaveAllowancesGetApiV2BusinessByBusinessIdLeaveallowancesByEmployeeIdDictionaryStringIList1",
    "AuLeaveAllowancesGetDictionaryStringIList1",
    "AuLeaveAllowancesRequest",
    "AuLeaveAllowancesRequestDictionaryStringIList1",
    "AuLeaveAllowancesRequestIdType",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModel",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualCapType",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualCarryOverBehaviour",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModelLeaveAccrualType",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModelNullableLeaveAllowanceUnitEnum",
    "AuLeaveAllowanceTemplateLeaveCategoryApiModelNullableLeaveUnitTypeEnum",
    "AuLeaveAllowanceTemplateModel",
    "AuLeaveAllowanceTemplateModelExternalService",
    "AuLeaveAllowanceTemplateModelNullableLeaveAccrualStartDateType",
    "AuLeaveBalancesExportModel",
    "AuLeaveBalancesExportModelLeaveUnitTypeEnum",
    "AuLeaveCategoryModel",
    "AuLeaveCategoryModelAuLeaveCategoryTypeEnum",
    "AuLeaveCategoryModelLeaveAllowanceUnitEnum",
    "AuLeaveCategoryModelLeaveUnitTypeEnum",
    "AuLeaveLiabilityExportModel",
    "AuLeaveLiabilityExportModelLeaveUnitTypeEnum",
    "AuLocationModel",
    "AuManagerRosterDataModel",
    "AuManagerRosterShiftGetFilterShiftStatus",
    "AuManagerRosterShiftGetRosterShiftStatus",
    "AuManagerRosterShiftModel",
    "AuManagerRosterShiftModelNullableShiftAssignmentStatusEnum",
    "AuOpeningBalancesModel",
    "AuOrdinaryTimeEarningsApiModel",
    "AuPayCategoriesModel",
    "AuPayCategoryModel",
    "AuPayCategoryModelAuPayCategoryType",
    "AuPayCategoryModelNullableMidpointRounding",
    "AuPayCategoryModelNullablePayCategoryPaymentSummaryClassification",
    "AuPayCategoryModelRateUnitEnum",
    "AuPaymentHistoryModel",
    "AuPayRateTemplateModel",
    "AuPayRunDeductionResponse",
    "AuPayRunDeductionResponseDictionaryStringList1",
    "AuPayRunDetailsModel",
    "AuPayRunEarningsLineResponseModel",
    "AuPayRunEarningsLineResponseModelDictionaryStringList1",
    "AuPayRunGrandTotalModel",
    "AuPayRunInclusionExportModel",
    "AuPayRunPaySlipGetDictionaryStringAuApiPaySlipModel",
    "AuPayRunTotalDetailModel",
    "AuPayRunTotalModel",
    "AuPayRunTotalResponse",
    "AuPayRunTotalResponseDictionaryStringAuPayRunTotalModel",
    "AuPayScheduleModel",
    "AuPayScheduleModelAuPayCycleFrequencyEnum",
    "AuPayScheduleModelNullablePayRunEmployeeSelectionStrategy",
    "AuReportsDetailedActivityGetExcelFileRequestFilterType",
    "AuReportsDetailedActivityGetExcelFileRequestGroupBy",
    "AuReportsGrossToNetGetExcelReportRequestFilterType",
    "AuReportsGrossToNetGetRequestFilterType",
    "AuReportsLeaveBalancesGetExcelReportRequestFilterType",
    "AuReportsLeaveBalancesGetExcelReportRequestGroupBy",
    "AuReportsLeaveBalancesGetRequestGroupBy",
    "AuReportsLeaveLiabilityGetRequestFilterType",
    "AuReportsLeaveLiabilityGetRequestGroupBy",
    "AuReportsPayrollTaxGetRequestGroupBy",
    "AuReportsPayRunInclusionsGetRequestStatus",
    "AuReportsRosterTimesheetComparisonGetRosterShiftStatus",
    "AuReportsRosterTimesheetComparisonGetTimesheetLineStatusType",
    "AuReportsSuperContributionsGetExcelReportRequestContributionType",
    "AuReportsSuperContributionsGetExcelReportRequestFilterType",
    "AuReportsSuperContributionsGetExcelReportRequestGroupBy",
    "AuReportsSuperContributionsGetExcelReportRequestSuperContributionsReportExportType",
    "AuReportsTimesheetGetTimesheetLineStatusType",
    "AuRosterShiftEditModel",
    "AuRosterShiftGenerateTimesheetModel",
    "AuRosterShiftGenerateTimesheetModelNullableShiftAssignmentStatusEnum",
    "AuRosterShiftGetFilterShiftStatus",
    "AuRosterShiftGetRosterShiftStatus",
    "AuRosterShiftMatchingResultModel",
    "AuRosterTimesheetComparisonReportExportModel",
    "AuRosterTimesheetComparisonReportRequestModel",
    "AuRosterTimesheetComparisonReportRequestModelRosterShiftStatus",
    "AuRosterTimesheetComparisonReportRequestModelTimesheetLineStatusType",
    "AuSaveBankAccountResponseModel",
    "AuSingleLocationModel",
    "AuSmsfElectronicServiceAddressModel",
    "AuStpRegistrationModel",
    "AuStpRegistrationModelAtoIntegrationOption",
    "AuStpRegistrationModelAtoSupplierRole",
    "AuSubmitPayRunEarningsLineRequest",
    "AuSubmitPayRunEarningsLineRequestDictionaryStringList1",
    "AuSubmitPayRunEarningsLineRequestIdType",
    "AuSubmitTimesheetsRequest",
    "AuSubmitTimesheetsRequestIDictionaryStringIList1",
    "AuSubmitTimesheetsRequestIdType",
    "AuSubmitTimesheetsResponse",
    "AuSubmitTimesheetsResponseIDictionaryStringIList1",
    "AuTimeAndAttendanceKioskModel",
    "AuTimeAndAttendanceLookupDataModel",
    "AuTimeAndAttendanceShiftModel",
    "AuTimesheetExportModel",
    "AuTimesheetLineModel",
    "AuTimesheetLineModelExternalService",
    "AuTimesheetReferenceData",
    "AuUnstructuredEmployeeModel",
    "AuUnstructuredEmployeeModelEmployeeStatusEnum",
    "AuUnstructuredEmployeeModelNullableCloselyHeldReportingEnum",
    "AuUnstructuredEmployeeModelNullableLeaveAccrualStartDateType",
    "AuUnstructuredEmployeeModelNullableMedicareLevySurchargeWithholdingTier",
    "AuUnstructuredEmployeeModelNullableStpIncomeTypeEnum",
    "AuUnstructuredEmployeeModelNullableTaxFileDeclarationTaxCategoryCombination",
    "AuUserAccountMetadata",
    "AuUserAccountPartnerMetadata",
    "AuWorkTypeModel",
    "AuWorkTypeModelAuEmploymentTypeEnum",
    "AuWorkTypeModelNullableWorkTypeMappingType",
    "AvailableEmployeeModel",
    "BankAccountEditModel",
    "BankAccountEditModelBankAccountTypeEnum",
    "BankAccountEditModelExternalService",
    "BankAccountEditModelIDictionaryStringString",
    "BasicEmploymentAgreementModel",
    "BasicEmploymentAgreementModelAuEmploymentTypeEnum",
    "BasicKioskEmployeeModel",
    "BasicKioskEmployeeModelTimeAttendanceStatus",
    "BiddingEmployee",
    "BirthdayReportExportModel",
    "BrandModel",
    "BulkApplyLeaveRequestModel",
    "BusinessAbaModel",
    "BusinessAbaModelNullablePaymentFileBalanceAdditionalContent",
    "BusinessAbaModelNullablePaymentFilePaymentAdditionalContent",
    "BusinessAccessListModel",
    "BusinessAccessListModelRelatedUserType",
    "BusinessAccessModel",
    "BusinessAccessModelRelatedUserType",
    "BusinessAction",
    "BusinessAtoSupplierModel",
    "BusinessAtoSupplierModelAtoSupplierRole",
    "BusinessMetadataOmopModel",
    "BusinessTemplateModel",
    "ByteArrayContent",
    "ChangeKioskPinModel",
    "ChartOfAccountsCategoryModel",
    "ChartOfAccountsLeaveCategoryModel",
    "ChartOfAccountsLiabilityCategoryModel",
    "ChartOfAccountsLiabilityLocationCategoryModel",
    "ChartOfAccountsLocationCategoryModel",
    "ChartOfAccountsLocationLeaveCategoryModel",
    "CheckKioskEmployeeIdModel",
    "CheckKioskPinModel",
    "ClassificationLookupModel",
    "ClassificationSelection",
    "ClassificationSelectModel",
    "ClockOffModel",
    "ClockOffModelNullableTimeAttendanceShiftNoteVisibility",
    "ClockOnModel",
    "ClockOnModelNullableTimeAttendanceShiftNoteVisibility",
    "CommunicationMessageAttachmentModel",
    "ConversationStatusUpdateHookModel",
    "CostingReportRequestModel",
    "CreateBusinessAccessModel",
    "CreateBusinessAccessModelRelatedUserType",
    "CreateEmployeeAccessModel",
    "CreateEmployeeNoteModel",
    "DeclineLeaveRequest",
    "DeclineReason",
    "DeductionModel",
    "DeductionsReportDeductionAmountModel",
    "DeductionsReportExportModel",
    "DeductionsReportRequestModel",
    "DetailedActivityReportRequestModel",
    "DetailedActivityReportRequestModelDateTypeEnum",
    "DetailedActivityReportRequestModelEarningsReportDisplayEnum",
    "DetailedPayRunWarningModel",
    "DetailedPayRunWarningModelPayRunWarningType",
    "DeviceTokenModel",
    "DeviceTokenModelMobilePlatform",
    "DimensionEarningsLineSplitApiModel",
    "DocumentAcknowledgementsReportExportModel",
    "DocumentFile",
    "DocumentModel",
    "EarningsLineSplitApiModel",
    "EarningsLineSplitEditModel",
    "EmergencyContactEditModel",
    "EmployeeAccessModel",
    "EmployeeAgreement",
    "EmployeeAgreementObject",
    "EmployeeDetailsAuditReportApiModel",
    "EmployeeDetailsAuditReportRequestModel",
    "EmployeeDetailsAuditReportRequestModelNullableEmployeeAuditSection",
    "EmployeeDetailsFields",
    "EmployeeDetailsModel",
    "EmployeeDetailsReportField",
    "EmployeeDetailsReportRequestModel",
    "EmployeeDocumentModel",
    "EmployeeEmergencyContactsEditModel",
    "EmployeeExpenseCategoryModel",
    "EmployeeExpenseModel",
    "EmployeeExpenseModelIDictionaryStringIList1",
    "EmployeeExpensePaymentSummaryModel",
    "EmployeeGroupAccessModel",
    "EmployeeGroupAccessModelUserPermission",
    "EmployeeGroupItemModel",
    "EmployeeGroupPermissionModel",
    "EmployeeItemCountModel",
    "EmployeeLeaveRequestFilter",
    "EmployeeMetadataOmopModel",
    "EmployeeNoteModel",
    "EmployeePartialEditModel",
    "EmployeePartialEditModelEmployeeStarterTypeEnum",
    "EmployeePartialEditModelEmployeeTimesheetSetting",
    "EmployeePartialEditModelExternalService",
    "EmployeePartialEditModelIDictionaryStringString",
    "EmployeePartialEditModelNullableAddressTypeEnum",
    "EmployeePublicHolidayFilter",
    "EmployeeQualificationDocumentModel",
    "EmployeeQualificationModel",
    "EmployeeQualificationRequest",
    "EmployeeRecurringExpenseModel",
    "EmployeeRecurringSuperAdjustmentModel",
    "EmployeeRecurringSuperAdjustmentModelSuperAdjustmentTypeEnum",
    "EmployeeRecurringSuperAdjustmentModelSuperContributionType",
    "EmployeeRecurringTaxAdjustmentModel",
    "EmployeeRecurringTaxAdjustmentModelTaxAdjustmentTypeEnum",
    "EmployeesFilter",
    "EmployeeTimesheetFilter",
    "EmployeeUnavailabilityFilter",
    "EmployeeUpdateResponseModel",
    "EmployeeViewModel",
    "EmployerLiabilityCategoryModel",
    "EmployerLiabilityModel",
    "EmployerRecurringLiabilityModel",
    "EmployerRecurringLiabilityModelEmployerRecurringLiabilityTypeEnum",
    "EmployerRecurringLiabilityModelExternalService",
    "EmploymentAgreementModel",
    "EmploymentAgreementModelEmploymentTypeEnum",
    "EmploymentAgreementModelExternalService",
    "EmploymentAgreementModelPayRateTemplateTypeEnum",
    "EmploymentAgreementPayRateTemplateModel",
    "EmploymentTerminationPayment",
    "EmploymentTerminationPaymentEtpTypeEnum",
    "EndBreakModel",
    "EndBreakModelNullableTimeAttendanceShiftNoteVisibility",
    "EntitlementFeatureModel",
    "EntitlementsModel",
    "EssBulkAcceptRosterShiftsModel",
    "EssBulkDeclineRosterShiftsModel",
    "EssBulkRosterShiftSwapModel",
    "EssCurrentExpensesModel",
    "EssCurrentShiftModel",
    "EssCurrentShiftModelTimeAttendanceStatus",
    "EssCurrentTimesheetsModel",
    "EssDeclineRosterShiftModel",
    "EssDocumentModel",
    "EssEmployeeDetailsModel",
    "EssEmployeeDetailsModelEmployeeDetailsEditMode",
    "EssEmployeeDetailsModelEmployeeTimesheetSetting",
    "EssEmployeeDetailsModelNullableAddressTypeEnum",
    "EssEmployeeDetailsModelTerminationReasonEnum",
    "EssEmployeeQualificationDocumentModel",
    "EssEmployeeQualificationModel",
    "EssExpenseRequestResponseModel",
    "EssExpenseUploadAttachmentIHttpActionResult",
    "EssLeaveCategoryModel",
    "EssLeaveCategoryModelLeaveUnitTypeEnum",
    "EssLeaveEstimate",
    "EssLeaveRequestModel",
    "EssLeaveRequestModelLeaveUnitTypeEnum",
    "EssLeaveUploadIHttpActionResult",
    "EssPaymentSummaryModel",
    "EssPayslipModel",
    "EssQualificationUploadAttachmentIHttpActionResult",
    "EssRosterShiftCountModel",
    "EssSatisfactionSurvey",
    "EssSatisfactionSurveyEmployeeSatisfactionValue",
    "EssShiftSwapCandidate",
    "EssTimesheetModel",
    "EssTimesheetModelExternalService",
    "EssTimesheetModelTimesheetLineStatusType",
    "EssUnavailabilityModel",
    "EssUnavailabilityModelNullableDayOfWeek",
    "EssUnavailabilityModelNullableDayOfWeekFlagsEnum",
    "EssWorkTypeModel",
    "EssWorkTypeModelEmploymentTypeEnum",
    "EssWorkTypeModelNullableWorkTypeMappingType",
    "ExpenseCategoryResponseModel",
    "ExpenseManagementFilterModel",
    "ExpenseManagementFilterModelNullableEmployeeExpenseRequestGroupBy",
    "ExpenseManagementFilterModelNullableEmployeeExpenseRequestStatus",
    "ExpenseReferenceData",
    "ExpenseRequestEditLineItemModel",
    "ExpenseRequestEditModel",
    "ExpenseRequestLineItemModel",
    "ExpenseRequestResponseModel",
    "ExpenseRequestUploadAttachmentIHttpActionResult",
    "ExpenseTaxCode",
    "FilterClause",
    "FilterQueryOption",
    "FilterQueryValidator",
    "FinalisePayRunOptions",
    "FinalisePayRunOptionsNullableHmrcFpsLateSubmissionReason",
    "FinalisePayRunOptionsNullablePayRunFinaliseActionPreference",
    "FinalisePayRunOptionsPublishPaySlipsPreference",
    "GenericManagerTimeAndAttendanceGetShiftNotesModelType",
    "GenericManagerTimeAndAttendanceGetShiftNotesModelVisibility",
    "GenericManagerTimesheetGetFilterOrderBy",
    "GenericManagerTimesheetGetFilterStatus",
    "GenericTimeAndAttendanceGetShiftNotesModelType",
    "GenericTimeAndAttendanceGetShiftNotesModelVisibility",
    "GetShiftNotesModel",
    "GetShiftNotesModelNullableTimeAttendanceShiftNoteType",
    "GetShiftNotesModelNullableTimeAttendanceShiftNoteVisibility",
    "GetShiftPeriodsModel",
    "GetShiftsModel",
    "GrossToNetReportRequest",
    "GrossToNetReportRequestNullableDateTypeEnum",
    "HourLeaveEstimateModel",
    "HourLeaveRequestModel",
    "HourLeaveRequestResponseModel",
    "IEdmDirectValueAnnotationsManager",
    "IEdmModel",
    "IEdmSchemaElement",
    "IEdmSchemaElementEdmSchemaElementKind",
    "IEdmTerm",
    "IEdmTermEdmSchemaElementKind",
    "IEdmTermEdmTermKind",
    "IEdmType",
    "IEdmTypeEdmTypeKind",
    "IEdmTypeReference",
    "IEdmVocabularyAnnotatable",
    "IEdmVocabularyAnnotation",
    "IFutureValueInt32",
    "ILeaveBasedRosterShift",
    "InitialEmployerLiabilityModel",
    "InitialLeaveBalanceModel",
    "InitialLeaveBalanceModelLeaveUnitTypeEnum",
    "InlineCountQueryOption",
    "InlineCountQueryOptionInlineCountValue",
    "InvoiceLineItemDetailModel",
    "InvoiceLineItemModel",
    "InvoiceModel",
    "InvoiceQueryOptionsModel",
    "JournalAccountBulkCreateModel",
    "JournalAccountModel",
    "JournalAccountModelExternalAccountType",
    "JournalExportResult",
    "JournalExportResultExternalService",
    "JournalExportResultJournalExportStatus",
    "JournalServiceProviderModel",
    "JournalServiceTaxCode",
    "KeyValuePairStringIEnumerable1",
    "KioskAccessModel",
    "KioskAccessModelKioskAccessType",
    "KioskAccessModelUserPermission",
    "KioskCreateEmployeeModel",
    "KioskEmployeeModel",
    "KioskEmployeeModelTimeAttendanceStatus",
    "LeaveAccrualModel",
    "LeaveAccrualResponse",
    "LeaveAccrualResponseDictionaryStringList1",
    "LeaveAllowanceTemplateLeaveCategoryModel",
    "LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualCapType",
    "LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualCarryOverBehaviour",
    "LeaveAllowanceTemplateLeaveCategoryModelLeaveAccrualType",
    "LeaveAllowanceTemplateLeaveCategoryModelNullableLeaveAllowanceUnitEnum",
    "LeaveAllowanceTemplateModel",
    "LeaveAllowanceTemplateModelExternalService",
    "LeaveAllowanceTemplateModelNullableLeaveAccrualStartDateType",
    "LeaveApplicationWithAttachmentModel",
    "LeaveBalanceModel",
    "LeaveBalanceModelLeaveUnitTypeEnum",
    "LeaveBalancesReportExportRequest",
    "LeaveBalancesReportExportRequestDateTypeEnum",
    "LeaveBalancesReportExportRequestLeaveReportDisplayEnum",
    "LeaveBalancesReportRequestModel",
    "LeaveBalancesReportRequestModelLeaveReportDisplayEnum",
    "LeaveEntitlementModel",
    "LeaveEntitlementModelLeaveEntitlementAccrualUnitType",
    "LeaveEntitlementModelLeaveEntitlementCarryOverType",
    "LeaveEntitlementModelLeaveEntitlementForfeitureType",
    "LeaveEntitlementModelLeaveEntitlementLeaveBalanceType",
    "LeaveEntitlementTierModel",
    "LeaveEntitlementTierModelLeaveEntitlementAccrualStartDateUnitType",
    "LeaveEntitlementTierModelLeaveEntitlementAccrualUnitType",
    "LeaveHistoryApiReportModel",
    "LeaveHistoryReportDetailModel",
    "LeaveHistoryReportDetailModelLeaveUnitTypeEnum",
    "LeaveHistoryReportGroupModel",
    "LeaveHistoryReportGroupModelLeaveUnitTypeEnum",
    "LeaveHoursEstimateFilter",
    "LeaveRequestFilterModel",
    "LeaveRequestFilterModelLeaveRequestGroupBy",
    "LeaveRequestFilterModelNullableLeaveRequestStatus",
    "LocationAccessModel",
    "LocationAccessModelLocationRestrictionFilterTypeEnum",
    "LocationAccessModelUserPermission",
    "LocationItemModel",
    "LocationModel",
    "LocationPermissionModel",
    "LocationSelectModel",
    "LocationShiftConditionsModel",
    "MagicTokenResponseModel",
    "ManagerBiddableRosterShiftModel",
    "ManagerBiddableRosterShiftModelNullableShiftAssignmentStatusEnum",
    "ManagerCurrentRosterShift",
    "ManagerCurrentRosterShiftTimeAttendanceStatus",
    "ManagerDashboardModel",
    "ManagerEmployeeGroup",
    "ManagerExpenseEmployeeModel",
    "ManagerExpenseGetFilterGroupBy",
    "ManagerExpenseGetFilterStatus",
    "ManagerExpenseRequestModel",
    "ManagerItemCountModel",
    "ManagerLeaveApplicationModel",
    "ManagerLeaveCategoryModel",
    "ManagerLeaveEmployeeModel",
    "ManagerLeaveEstimate",
    "ManagerLeaveRequestListLeaveRequestsFilterGroupBy",
    "ManagerLeaveRequestListLeaveRequestsFilterStatus",
    "ManagerLeaveRequestModel",
    "ManagerLeaveRequestModelLeaveUnitTypeEnum",
    "ManagerRosterEmployeeModel",
    "ManagerRosterShiftFilterModel",
    "ManagerTimesheetEmployeeModel",
    "ManagerTimesheetLineModel",
    "ManagerTimesheetLineModelExternalService",
    "ManagerTimesheetLineModelTimesheetLineStatusType",
    "ManagerTimesheetSubmitModel",
    "ManagerTimesheetSubmitModelNullableExternalService",
    "ManagerUnavailabilityModel",
    "ManagerUnavailabilityModelNullableDayOfWeek",
    "ManagerUnavailabilityModelNullableDayOfWeekFlagsEnum",
    "MarkNotesReadViewModel",
    "MatchingEmployeeModel",
    "MetadataLite",
    "MLCSuperReportExportModel",
    "NameIdPair",
    "NetToGrossModel",
    "NetToGrossRequest",
    "NewUserCreatedModel",
    "NewUserModel",
    "NominalClassification",
    "NominalLeaveCategory",
    "NominalLocation",
    "NominalWorkType",
    "NominalWorkTypeWorkTypeLinkTypeRestriction",
    "NumericNullableSelectListItem",
    "NumericSelectListItem",
    "ODataQueryContext",
    "ODataQueryValidator",
    "ODataRawQueryOptions",
    "OpeningBalancesEtpModel",
    "OpeningBalancesEtpModelEtpTypeEnum",
    "OrderByClause",
    "OrderByClauseOrderByDirection",
    "OrderByNode",
    "OrderByNodeOrderByDirection",
    "OrderByQueryOption",
    "OrderByQueryValidator",
    "OrdinaryTimeEarningsReportRequestModel",
    "OtherAmounts",
    "PagedResultModelManagerExpenseRequestModel",
    "PagedResultModelManagerTimesheetLineModel",
    "PagedResultModelSuburbModel",
    "PartiallyAppliedLeaveRequestBannerModel",
    "PayCategoriesReportRequestModel",
    "PayConditionRuleSetModel",
    "PayConditionRuleSetModelNullableShiftConsolidationOption",
    "PayConditionRuleSetModelRuleSetPeriodType",
    "PaygAdjustmentModel",
    "PaygReportExportModel",
    "PaygReportRequestModel",
    "PaymentHistoryReportRequestModel",
    "PayRateScheduleModel",
    "PayRateTemplateModel",
    "PayRateTemplatePayCategoryExportModel",
    "PayRateTemplatePayCategoryModel",
    "PayrollAccessModel",
    "PayrollAccessModelNullableBusinessRestrictionTypeEnum",
    "PayrollExemptReportExportModel",
    "PayrollExemptReportRequestModel",
    "PayrollExport",
    "PayrollTaxReportExportModel",
    "PayrollTaxReportRequestModel",
    "PayrollTaxReportRequestModelPayrollTaxGroupByEnum",
    "PayRunAuditReportRequestModel",
    "PayRunCreateAndFinaliseMultipleResponse",
    "PayRunCreateAndFinaliseMultipleResult",
    "PayRunCreateMultipleRequest",
    "PayRunCreateMultipleRequestDates",
    "PayRunCreateMultipleRequestNullableTimesheetImportOption",
    "PayRunCreateRequest",
    "PayRunCreateRequestNullableTimesheetImportOption",
    "PayRunEmployeeExpenseResponse",
    "PayRunEmployeeExpenseResponseDictionaryStringList1",
    "PayRunEmployerLiabilityResponse",
    "PayRunEmployerLiabilityResponseDictionaryStringList1",
    "PayRunFinaliseDefaultSettingsModel",
    "PayRunFinaliseDefaultSettingsModelPayRunFinaliseActionPreference",
    "PayRunFinaliseDefaultSettingsModelPayRunFinaliseActionTimeline",
    "PayRunFinaliseResult",
    "PayRunFinaliseResultPayRunFinaliseActionPreference",
    "PayRunFinaliseResultPublishPaySlipsPreference",
    "PayRunInclusionsReportRequestModel",
    "PayRunInclusionsReportRequestModelPayRunInclusionsStatus",
    "PayRunJobModel",
    "PayRunJobStatusModel",
    "PayRunModel",
    "PayRunNotationModel",
    "PayRunPaygAdjustmentResponse",
    "PayRunPaygAdjustmentResponseDictionaryStringList1",
    "PayRunSummaryModel",
    "PayRunSuperAdjustmentResponse",
    "PayRunSuperAdjustmentResponseDictionaryStringList1",
    "PayRunSuperBatchModel",
    "PayRunTotalModel",
    "PayRunTotalNotationModel",
    "PayRunUnlockRequest",
    "PayRunWarningDto",
    "PayRunWarningDtoObject",
    "PayRunWarningDtoPayRunWarningType",
    "PayRunWarningModel",
    "PayRunWarningResult",
    "PayScheduleApprovalSettingsModel",
    "PayScheduleDateForecastResultApiModel",
    "PayScheduleMetaDataModel",
    "PaySlipNotificationResponse",
    "PaySlipReportRequestModel",
    "PinResetModel",
    "ProfileImageMetadata",
    "PublicHolidayModel",
    "QualificationModel",
    "RangeVariable",
    "RateOverride",
    "RecoverPasswordModel",
    "RecoverPasswordModelMessageTypeEnum",
    "RelatedBusinessesModel",
    "ReportAccessModel",
    "ReportAccessModelReportAccessType",
    "ReportAccessModelReportEnum",
    "ReportingDimensionApiModel",
    "ReportingDimensionApiModelExternalService",
    "ReportingDimensionValueApiModel",
    "ReportingDimensionValueApiModelExternalService",
    "ReportingDimensionValueBaseApiModel",
    "ReportingDimensionValueFilterApiModel",
    "ReportingDimensionValueSelectModel",
    "ReportLeaveLiabilityPreparationResponse",
    "ReportLeaveLiabilityPreparationResponseLongRunningJobStatus",
    "ReportLeaveLiabilityRequestModel",
    "ReportLeaveLiabilityRequestModelDateTypeEnum",
    "ReportLeaveLiabilityRequestModelNullableLeaveReportDisplayEnum",
    "ReportPackModel",
    "ReportPayRunVarianceRequestModel",
    "ReportPayRunVarianceRequestModelPayRunComparisonType",
    "ReportRequestWithPayScheduleModel",
    "ReportsEmployeeAuditGetRequestSection",
    "ReportsEmployeeDetailsGetJObject",
    "ReportsEmployeeDetailsPostJObject",
    "ReportsPayRunVarianceReportGetExcelReportRequestComparisonType",
    "ReportsShiftSwappingGetRosterShiftSwapStatusEnum",
    "ReportsTasksReportGetRequestStatus",
    "ResellerModel",
    "RosterLiveLeaveAccruals",
    "RosterShiftBreakApiModel",
    "RosterShiftEditModel",
    "RosterShiftFilterModel",
    "RosterShiftFilterModelRosterShiftStatus",
    "RosterShiftRole",
    "RosterShiftSwapModel",
    "RuleEvaluationResult",
    "RuleEvaluationResultRuleMatchResult",
    "SaveLeaveAccrualModel",
    "SaveLeaveAccrualModelSaveLeaveAccrualTypeEnum",
    "SaveSuperFundModel",
    "SaveSuperFundResponseModel",
    "SelectExpandClause",
    "SelectExpandQueryOption",
    "SelectExpandQueryValidator",
    "SelectItem",
    "SelectListGroup",
    "SelectListItem",
    "SelfManagedSuperFundModel",
    "SetBillingPlanRequestModel",
    "SetPayRunUIUnlockStateRequest",
    "ShiftAllowanceModel",
    "ShiftAllowanceModelShiftAllowanceOption",
    "ShiftAllowanceModelShiftAllowanceType",
    "ShiftBreakModel",
    "ShiftBreakModelNullableTimeAttendanceShiftNoteVisibility",
    "ShiftCondition",
    "ShiftConditionModel",
    "ShiftConditionSelectModel",
    "ShiftCostingBreakdownModel",
    "ShiftCostingData",
    "ShiftCostingsEmployeeModel",
    "ShiftCostingsRequestModel",
    "ShiftCostingsRequestModelIdType",
    "ShiftCostingsRequestShiftModel",
    "ShiftCostingsRequestShiftModelExternalService",
    "ShiftCostingsResponseModel",
    "ShiftCostingsResponseShiftModel",
    "ShiftLiabilityModel",
    "ShiftLiabilityModelShiftAllowanceOption",
    "ShiftNoteViewModel",
    "ShiftNoteViewModelTimeAttendanceShiftNoteType",
    "ShiftNoteViewModelTimeAttendanceShiftNoteVisibility",
    "ShiftPartModel",
    "ShiftPeriodModel",
    "ShiftSwappingReportExportModel",
    "ShiftSwappingReportRequestModel",
    "ShiftSwappingReportRequestModelRosterShiftSwapStatusEnum",
    "SignupModel",
    "SingleSignOnRequestAdditionalDataModel",
    "SingleSignOnRequestModel",
    "SingleSignOnRequestModelNavigationDisplayEnum",
    "SingleSignOnResponseModel",
    "SingleValueNode",
    "SingleValueNodeQueryNodeKind",
    "SkipQueryOption",
    "SkipQueryValidator",
    "StandardHoursDayModel",
    "StandardHoursDayModelNullableWorkDayType",
    "StandardHoursModel",
    "StandardHoursModelNullableAdvancedWorkWeekConfigurationOption",
    "StartBreakModel",
    "StartBreakModelNullableTimeAttendanceShiftNoteVisibility",
    "StubRosterShiftViewModel",
    "SubmitLeaveAccrualsModel",
    "SubmitLeaveAccrualsModelDictionaryStringList1",
    "SubmitLeaveAccrualsModelIdType",
    "SubmitPayRunDeductionRequest",
    "SubmitPayRunDeductionRequestDictionaryStringList1",
    "SubmitPayRunDeductionRequestIdType",
    "SubmitPayRunEmployeeExpenseRequest",
    "SubmitPayRunEmployeeExpenseRequestDictionaryStringList1",
    "SubmitPayRunEmployeeExpenseRequestIdType",
    "SubmitPayRunEmployerLiabilityRequest",
    "SubmitPayRunEmployerLiabilityRequestDictionaryStringList1",
    "SubmitPayRunEmployerLiabilityRequestIdType",
    "SubmitPayRunPaygAdjustmentRequest",
    "SubmitPayRunPaygAdjustmentRequestDictionaryStringList1",
    "SubmitPayRunPaygAdjustmentRequestIdType",
    "SubmitPayRunSuperAdjustmentRequest",
    "SubmitPayRunSuperAdjustmentRequestDictionaryStringList1",
    "SubmitPayRunSuperAdjustmentRequestIdType",
    "SuburbModel",
    "SuburbResult",
    "SuperAccrualExportModel",
    "SuperAccrualExportModelNullableSuperInterchangeStatus",
    "SuperAdjustmentModel",
    "SuperContributionsReportExportModel",
    "SuperContributionsReportRequestModel",
    "SuperContributionsReportRequestModelContributionsServiceType",
    "SuperContributionsReportRequestModelDateTypeEnum",
    "SuperContributionsReportRequestModelNullableSuperContributionType",
    "SuperContributionsReportRequestModelSuperContributionsReportExportTypeEnum",
    "SuperFundModel",
    "SuperProductEditModel",
    "SuperProductEditModelExternalService",
    "SuperProductModel",
    "SuperProductModelExternalService",
    "SwapShiftModel",
    "SystemEventType",
    "TagViewModel",
    "TasksReportExportModel",
    "TasksReportNoteModel",
    "TasksReportRequestModel",
    "TasksReportRequestModelTasksReportStatusEnum",
    "TerminateEmployeeRequest",
    "TimeAndAttendanceBreakModel",
    "TimeAndAttendanceKioskModel",
    "TimesheetArray",
    "TimesheetBreakManagerModel",
    "TimesheetBreakModel",
    "TimesheetBreakModelv3",
    "TimesheetBreakSubmitModel",
    "TimesheetBreakViewModel",
    "TimesheetLineCommentsModel",
    "TimesheetLineModel",
    "TimesheetLineModelExternalService",
    "TimesheetPayReturnArray",
    "TimesheetReportRequestModel",
    "TimesheetReportRequestModelTimesheetLineStatusType",
    "TimesheetRequestFilterModel",
    "TimesheetRequestFilterModelNullableTimesheetGrouping",
    "TimesheetRequestFilterModelNullableTimesheetLineFilterStatus",
    "TimesheetRoundingRulesModel",
    "TimesheetRoundingRulesModelRoundingDirectionEnum",
    "TimesheetShiftConditionModel",
    "TimesheetShiftConditionModelv3",
    "TitleViewModel",
    "TokenPostRequest",
    "TopQueryOption",
    "TopQueryValidator",
    "UnavailabilityEditModel",
    "UnavailabilityEditModelNullableDayOfWeek",
    "UnavailabilityEditModelNullableDayOfWeekFlagsEnum",
    "UnavailabilityFilter",
    "UnavailabilityModel",
    "UnavailabilityModelNullableDayOfWeek",
    "UnavailabilityModelNullableDayOfWeekFlagsEnum",
    "UnavailabilitySaveModel",
    "UnavailabilitySaveModelNullableDayOfWeek",
    "UnitAndHourLeaveEstimateModel",
    "UpdateDocumentPermissionsModel",
    "UpdateEmployeeDocumentPermissionsModel",
    "UpdateUserModel",
    "UserAccessModel",
    "UserAccessModelNullableRelatedUserType",
    "UserAccountMetadataLite",
    "UserAccountMetadataOmopModel",
    "UserModel",
    "UserUpdatedModel",
    "WebHook",
    "WebHookIDictionaryStringObject",
    "WebHookIDictionaryStringObjectObject",
    "WebHookIDictionaryStringString",
    "WebHookRegistrationsDeleteAllIHttpActionResult",
    "WebHookRegistrationsDeleteIHttpActionResult",
    "WebHookRegistrationsPutIHttpActionResult",
    "WebHookRegistrationsTestIHttpActionResult",
    "WhiteLabelActiveEmployeesRequestModel",
    "WhiteLabelBrandingModel",
    "WhiteLabelModel",
    "WhiteLabelReportSignupsRequestModel",
    "WorkersCompReportGridModel",
    "WorkTypeSelectModel",
)
